//---------------------------------------------------------------------
//
//	Copyright  1992 David Peterson.
//	All rights reserved.
//
//	Permission to use, copy, modify, and distribute this software for
//	any purpose and without fee is hereby granted, provided that the
//	above copyright notice appear in all copies and that both that
//	copyright notice and this permission notice appear in supporting
//	documentation.
//
//---------------------------------------------------------------------

#include "FingerD.h"

#include <TCP.h>

#include <String.h>
#include <Strings.h>
#include <Desk.h>
#include <StdIO.h>
#include <Resources.h>
#include <Sysequ.h>

void main();

void
main()
{
	InitUDaemonApp(*((long*) DefltStack));

	FingerD* aDaemon = new FingerD;
	if (aDaemon) {
		aDaemon->Initialize();
		aDaemon->Run();

		delete aDaemon;
	}
}

void 
FingerD::InstallAEHandlers()
{
	Inherited::InstallAEHandlers();

	OSErr	theErr;

	theErr = AEInstallEventHandler('INET', 'TSTR', 
				(EventHandlerProcPtr) &AEStreamHandler, (long) this, false);

	if (theErr != noErr)
		ExitToShell();
}

pascal OSErr 
AEStreamHandler(AppleEvent* messagein, AppleEvent* /*reply*/, long refIn)
{
	AEDesc		streamDesc;
	OSErr		theErr;
	StreamPtr	stream;

	if ((theErr = AEGetParamDesc(messagein, 'STRM', typeLongInteger, &streamDesc)) == noErr) {
		HLock(streamDesc.dataHandle);
		stream = *((StreamPtr*) *streamDesc.dataHandle);
		HUnlock(streamDesc.dataHandle);
		
		theErr = AEDisposeDesc(&streamDesc);
	}

	((FingerD*) refIn)->HandleNewStream(stream);

	return theErr;
}

void
FingerD::HandleNewStream(StreamPtr stream)
{
	Handle	macName;
	Handle	whoName;
	
	char	out[256];
	char	time[64];
	char*	name	= "Macintosh belongs to:\t";
	char*	machine	= "Macintosh is named:\t";
	
	long	secs;
	long	mins;
	long	hour;
	
	macName = GetResource('STR ', -16413);
	HLock(macName);
	whoName = GetResource('STR ', -16096);
	HLock(whoName);

	secs = TickCount() / 60;
	mins = secs / 60;
	hour = mins / 60;
	
	secs -= mins * 60;
	mins -= hour * 60;
	
	sprintf(time, "Has been up for:\t%02d:%02d:%02d", hour, mins, secs);
	sprintf(out, "%s%P\r%s%P\r%s\r", name, *whoName, machine, *macName, time);
	
	tcpWrite(stream, out, strlen(out));
	tcpClose(stream);
	
	HUnlock(macName);
	ReleaseResource(macName);
	HUnlock(whoName);
	ReleaseResource(whoName);

	this->DoQuit();
}

