/* TestBed.c
 * Word Services Testbed - main module for Writeswell Jr.
 *
 * 1992 Working Software, Inc.
 * This source code is copyrighted.  Permission is granted to use the Word Services
 * portion of the Writeswell Jr. source code in your own programs, but you 
 * may not distribute the Writeswell Jr. word-processor code as a 
 * commercial product.  If you modify the code, please do not call it 
 * Writeswell Jr. (or Writeswell.)  This will ensure that people understand the 
 * program and dont have to deal with a number of different versions with 
 * who-knows-what going on in the code.
 * 
 * Writeswell Jr. and Writeswell are trademarks of Working Software, Inc.
*/

#include <EPPC.h>
#include <AppleEvents.h>
#include <AEObjects.h>
#include <Printing.h>
#include "AERegistry.h"
#include "WordServices.h"
#include "TestBed.h"
#include "TBConstants.h"
#include "MyFiles.h"
#include "GenHandlers.h"
#include "AppEvents.h"
#include "AEObj.h"
#include "InitMenu.h"
#include "Gripe.h"
#include "Scroll.h"
#include "Prefs.h"
#include "DoChecking.h"
#include "ServiceMgr.h"
#include "ObWind.h"
#include "ObText.h"
#include "ObNull.h"
#include "ObOspec.h"
#include "FontMenu.h"
#include "Options.h"
#include "ServiceDialog.h"
#include "PrintWWJr.h"
#include "UnloadStuff.h"
#include "PageSetup.h"

void UnloadStuff( void )
{
	UnloadForPrint();
	UnloadSeg( DoPrint );
	
	return;
}

void UnloadForPrint( void )
{
	/* Unload all the segments but the print segment, so that as much memory is
	 * released as possible while printing
	 */

	UnloadSeg( DoOpenDialog );
	UnloadSeg( DispatchOspec );
	UnloadSeg( DispatchWind );
	UnloadSeg( DispatchTEText );
	UnloadSeg( DispatchNull );
	UnloadSeg( DoControl );
	UnloadSeg( DoSpellCheck );
	UnloadSeg( PutUpMenus );
	UnloadSeg( DoFontMenu );
	UnloadSeg( OptionsDialog );
	UnloadSeg( DoOpenDialog );
	UnloadSeg( DoPageSetup );

	return;
}

