//		TCircleCityMap.cp
// Copyright  1992 Emergent Behavior. All rights reserved.


#ifndef _CIRCLECITYMAP_
	#include "CircleCityMap.h"
#endif

#ifndef _GAFAILURE_
	#include "GAFailure.h"
#endif

//-------------------------------------------------------------------------------------------------------
TCircleCityMap::TCircleCityMap( void )
	:	TCityMap()
{
	
}

//-------------------------------------------------------------------------------------------------------
TCircleCityMap::TCircleCityMap( const TCityMap& sourceMap )
	:	TCityMap( sourceMap )
{

}

//-------------------------------------------------------------------------------------------------------
TCircleCityMap::TCircleCityMap( CityNumber numCities )
	:	TCityMap()
{
	this->SetNumberCities( numCities );
	this->AllocateDistanceTable();

	this->SetCityLocations( new Point[ this->GetNumberCities() ]);
	
	this->DecideCityLocations();
	this->GenerateDistanceTable();
}

//-------------------------------------------------------------------------------------------------------
TCircleCityMap::~TCircleCityMap( void )
{
}

//-------------------------------------------------------------------------------------------------------
TCityMap*
TCircleCityMap::Clone( void )
{
	TCircleCityMap* copy = new TCircleCityMap(*this);
	FailNIL(copy);
	return copy;
}

 //-------------------------------------------------------------------------------------------------------
void		
TCircleCityMap::DecideCityLocations( void )
{
	short x;
	short y;
	float radius = 1000.0;
	float deltaTheta = 2. * 3.14159 / (float) GetNumberCities();  // radians
	float theta;
	Point* cityLocs = GetCityLocations();
	short numCities = GetNumberCities();
	for ( short cityIndex = 0; cityIndex < numCities; ++cityIndex ) {
		theta = cityIndex * deltaTheta;
		x = radius * cos(theta);
		y = radius * sin(theta);
		cityLocs[ cityIndex ]	= TPoint(x, y);
		}
	float x0 = radius;
	float x1 = radius * cos(deltaTheta);
	float y0 = 0;
	float y1 = radius * sin(deltaTheta);
	fShortestDistance = (float) numCities * sqrt( (x1 - x0)*(x1 - x0) + (y1 - y0)*(y1-y0) );
}

 //-------------------------------------------------------------------------------------------------------
float
TCircleCityMap::GetShortestDistance()
{
	return fShortestDistance;
}