//		TMyIndividual.cp
// Copyright  1992 Emergent Behavior. All rights reserved.

#ifndef _MYINDIVIDUAL_
	#include "MyIndividual.h"
#endif

#ifndef _GAFAILURE_
	#include "GAFailure.h"
#endif

//==================================================================================
TMyIndividual::TMyIndividual( TCityMap* cityMap )
	: fCityMap( cityMap ),
	TIndividual(cityMap->GetNumberCities() )
{

}

//----------------------------------------------------------------------------------
TMyIndividual::TMyIndividual( const TMyIndividual& sourceInd )
	: fCityMap ( sourceInd.fCityMap ),
	TIndividual( sourceInd )
{	
}

//----------------------------------------------------------------------------------
TMyIndividual::~TMyIndividual(void)
{	
}

//----------------------------------------------------------------------------------
void
TMyIndividual::CalcObjective( void )
{
	Importance* importanceArray = new Importance [ GetNumberGenes() ];
	FailNIL(importanceArray);
	short numberCities			= GetNumberGenes();
	
	for ( short cityIndex = 0; cityIndex < numberCities; ++cityIndex )
	{
		importanceArray[ cityIndex ] = (short)(GetGene( cityIndex ).GetValue());
	}
	
	float distance	= fCityMap->CalcRouteDistance( importanceArray );
	
	this->SetObjective( ( distance * (-1)) );
	delete importanceArray;
}

//----------------------------------------------------------------------------------
TSimulationUnit*
TMyIndividual::Clone( void )
{
	TMyIndividual* copy = new TMyIndividual(*this);
	FailNIL(copy);
	return copy;
}

//----------------------------------------------------------------------------------
void
TMyIndividual::MakeGenes( void )
{
	short numberCities 	= GetNumberGenes();
	TGAList& geneList	= GetGeneList();
	TGene* gene;
	for ( short cityIndex = 0; cityIndex < numberCities; ++cityIndex )
	{
		gene = new TGene ( 1, numberCities );
		FailNIL(gene);
		geneList.AdoptItem(gene);
	}
}

//----------------------------------------------------------------------------------
TMyIndividual&
TMyIndividual::operator=( const TMyIndividual& sourceInd )
{
	if ( &sourceInd != this )
	{
		TIndividual::operator=(sourceInd);
		fCityMap = sourceInd.fCityMap;
	}
	return *this;
}
