//	PathGraph.h
// Copyright  1992 Emergent Behavior. All rights reserved.

#ifndef _PATHGRAPH_
#define _PATHGRAPH_

#ifndef _CITYMAP_
	#include "CityMap.h"
#endif

#ifndef _PLOTTER_
	#include "Plotter.h"
#endif
//========================================================================
class TPathGraph
{
public:
		// Constructors etc...
						TPathGraph( void );
						TPathGraph( const TPathGraph& sourcePathGraph );
						TPathGraph( const TCityMap& aCityMap, GrafPtr grafPort, Rect qdRect );
	virtual				~TPathGraph( void );
	virtual TPathGraph*	Clone( void );
	virtual	void		SetGrafPort( GrafPtr grafPort );
	virtual void		SetQDRect( Rect qdRect );
	virtual void		PlotCityLocations( void );
	virtual	void		PlotRoute( Importance* importanceArray );
	virtual TCityMap*	GetCityMap( void );

protected:
	virtual	GrafPtr		GetGrafPort( void );
	virtual	Rect		GetQDRect( void );
	virtual	TPlotter*	GetPlotter( void );
	virtual	short		FindLargestDimension( Point* cityLocationArray );
	

private:
	GrafPtr		fGrafPort;
	Rect		fQDRect;
	TPlotter*	fPlotter;
	TCityMap*	fCityMap;

};


#endif _PATHGRAPH_