#ifndef NETSCAPESTREAM_H
#include "NetscapeStream.h"
#endif

#include <string.h>

const long CNetscapeStream::kMaxBufSize = 0X0FFFFFFF;

CNetscapeStream::CNetscapeStream( NPMIMEType type, NPStream* stream, NPBool seekable, uint16 stype )
:	fSourceStream( stream ),
	fMIMEType( 0 ),
	fSeekable( seekable ),
	fStreamType( stype )
{
	fSourceStream->pdata = (void*) this;
	
	short mimeLength = strlen( type );
	fMIMEType = (char*) NPN_MemAlloc( mimeLength + 1 );
	strcpy( fMIMEType, type );
}

CNetscapeStream::~CNetscapeStream()
{
	fSourceStream->pdata = 0;
	NPN_MemFree( fMIMEType );
}

CNetscapeStream*
CNetscapeStream::EvolveStream( NPStream* npStream )
{
	return (CNetscapeStream*) npStream->pdata;
}

const char*
CNetscapeStream::GetURL() const 
{ 
	if( fSourceStream ) 
		return fSourceStream->url; 
	return 0;
}
