#pragma once

#ifndef _NPAPI_H_
#include "npapi.h"
#endif

#include "NetscapeMemObject.h"

class CNetscapeStream : public CNetscapeMemObject {
	public:
							CNetscapeStream( NPMIMEType type, NPStream* stream, NPBool seekable, uint16 stype );
		virtual				~CNetscapeStream();
		
		virtual long		WriteReady() 
									{ return kMaxBufSize; };
		virtual long		Write( int32 offset, int32 len, void *buffer ) 
									{ return len; };
		virtual NPError		Finish( NPError reason ) 
									{ return NPERR_NO_ERROR; };
		virtual void		StreamAsFile( const char* fname ) 
									{ };
									
		unsigned short		GetStreamType() const { return fStreamType; };
		const char*			GetURL() const;
		NPStream*			GetSourceStream() { return fSourceStream; };
		
		static CNetscapeStream*	EvolveStream( NPStream* npStream );
	
	protected:
		void				SetSeekable( NPBool seekable )
									{ fSeekable = seekable; };
									
	private:
		static const long	kMaxBufSize;
		
		
		NPStream*			fSourceStream;
		char*				fMIMEType;
		NPBool				fSeekable;
		unsigned short		fStreamType;
};
