#pragma once

#ifndef NETSCAPEMEMOBJECT_H
#include "NetscapeMemObject.h"
#endif

class CArgumentNode : public CNetscapeMemObject {
	public:
							CArgumentNode( char* adoptArgumentName, char* adoptArgumentValue );
		virtual				~CArgumentNode();
	
		const CArgumentNode*	FindArgumentByName( const char* normalArgName ) const;
		const char*			GetArgumentName() const;
		const char*			GetArgumentValue() const;
		void				AdoptChildArgument( CArgumentNode* adoptedArg );

	private:
		char*				fArgumentName;
		char*				fArgumentValue;
		
		CArgumentNode*		fLesserChild;
		CArgumentNode*		fGreaterChild;
};


class CPluginArguments : public CNetscapeMemObject {
	public:
							CPluginArguments( short argc, const char* argn[], const char* argv[] );
		virtual				~CPluginArguments();
		
		const char*			ArgumentValueAsString( const char* argumentName );
		long				ArgumentValueAsInt( const char* argumentName, long defaultValue = 0 );
		Boolean				ArgumentValueAsBool( const char* argumentName, Boolean defaultValue=false );
		
	private:
		CArgumentNode*		fTopArgument;
		char				fEmptyString[1];		
			
};
