//========================================================================================
//
//	File:				Part.cpp
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PART_H
#include "Part.h"
#endif

#ifndef FRAME_H
#include "Frame.h"
#endif

#ifndef DEFINES_K
#include "Defines.k"
#endif

#ifndef BINDING_K
#include "Binding.k"
#endif

// ----- Framework Includes -----

#ifndef FWUTIL_H
#include "FWUtil.h"
#endif

#ifndef FWCFMRES_H
#include "FWCFMRes.h"
#endif

#ifndef FWABOUT_H
#include "FWAbout.h"
#endif

//========================================================================================
//	Runtime informations
//========================================================================================

#ifdef FW_BUILD_MAC
#pragma segment machack
#endif

//========================================================================================
//	CLASS CMacHackPart
//========================================================================================


FW_DEFINE_AUTO(CMacHackPart)
	
//----------------------------------------------------------------------------------------
//	 CMacHackPart::CMacHackPart
//----------------------------------------------------------------------------------------

CMacHackPart::CMacHackPart(ODPart* odPart):
	FW_CPart(odPart, FW_gInstance, kPartInfoID)
{
}

//----------------------------------------------------------------------------------------
//	 CMacHackPart::~CMacHackPart
//----------------------------------------------------------------------------------------

CMacHackPart::~CMacHackPart()
{
}

//----------------------------------------------------------------------------------------
//	 CMacHackPart::Initialize
//----------------------------------------------------------------------------------------

void CMacHackPart::Initialize(Environment* ev)
{
	FW_CPart::Initialize(ev);
	
	RegisterPresentation(ev, "Apple:Presentation:MacHack", TRUE);
}

//----------------------------------------------------------------------------------------
//	 CMacHackPart::NewFrame
//----------------------------------------------------------------------------------------

FW_CFrame* CMacHackPart::NewFrame(Environment* ev, 
								  ODFrame* odFrame, 
								  FW_CPresentation* presentation, 
								  FW_Boolean fromStorage)
{
FW_UNUSED(presentation);
FW_UNUSED(fromStorage);
	
	return FW_NEW(CMacHackFrame, (ev, odFrame, presentation, this));
}

//----------------------------------------------------------------------------------------
//	 CMacHackPart::NewPartContent
//----------------------------------------------------------------------------------------

FW_CContent* CMacHackPart::NewPartContent(Environment* ev)
{
	return NULL;
}

//----------------------------------------------------------------------------------------
//	CMacHackPart::DoMenu
//----------------------------------------------------------------------------------------

FW_Boolean CMacHackPart::DoMenu(Environment* ev, const FW_CMenuEvent& theMenuEvent)
{
	FW_Boolean result = TRUE;
	ODCommandID commandID = theMenuEvent.GetCommandID(ev);

	switch (commandID)
	{
		case kODCommandAbout:
			::FW_About(ev, this, kAbout);
			break;
						
		default:
			result = false;		
	}
	
	return result;
}
