//========================================================================================
//
//	File:				Part.h
//	Release Version:	$ ODF 1 $
//
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PART_H
#define PART_H

// ----- Framework Includes -----

#ifndef FWPART_H
#include "FWPart.h"
#endif

//========================================================================================
// Forward Class Desclarations
//========================================================================================

class FW_CShape;

//========================================================================================
//	CLASS CMacHackPart
//========================================================================================

class CMacHackPart : public FW_CPart
{
public:
	FW_DECLARE_AUTO(CMacHackPart)

//----------------------------------------------------------------------------------------
//	Initialization/Destruction
//
public:
	CMacHackPart(ODPart* odPart);
	virtual ~CMacHackPart();

	virtual void Initialize(Environment* ev);
	
//----------------------------------------------------------------------------------------
//	Inherited API
//
public:
	virtual FW_CContent* 	NewPartContent(Environment* ev);
	virtual FW_CFrame* 		NewFrame(Environment* ev,
									ODFrame* odFrame, 
									FW_CPresentation* presentation,
									FW_Boolean fromStorage);
	virtual FW_Boolean		DoMenu(Environment* ev, const FW_CMenuEvent& theMenuEvent);
	virtual FW_Boolean		DoAdjustMenus(Environment* ev, FW_CMenuBar* menuBar, FW_Boolean hasMenuFocus, FW_Boolean isRoot);

//----------------------------------------------------------------------------------------
//	New API
//
public:
	void					NextGeometry(Environment* ev);

	FW_CShape*				GetShape(short index) const
								{return fShapes[index];}

private:
	void					ChangeGeometry(Environment* ev, ODCommandID geometry);
	void					CreateShapes();
	void					DeleteShapes();
	
//----------------------------------------------------------------------------------------
//	Data Member
//
private:
	FW_CPresentation*	fPresentation;
	FW_CShape*			fShapes[3];
	ODCommandID			fGeometry;
};

#endif
