//========================================================================================
//
//	File:				Views.fr
//	Release Version:	$ ODF 1 $
//
//	Contains:			Common (Platform independent) resources for the MacHack part
//
//	Copyright:	(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWRESFIL_K
#include "FWResFil.k"
#endif

#ifndef FWVIEWS_FR
#include "FWViews.fr"
#endif

#ifndef FWNOTDEF_H
#include "FWNotDef.h"	 
#endif

#ifndef DEFINES_K
#include "Defines.k"
#endif

//========================================================================================
// type RMacHackView
//========================================================================================
// RMacHackView doesn't add any field to FW_RSuperView
// IMPORTANT: the resource label below must match LMacHackView declared in the .cpp file 

type RMacHackView : FW_RSuperView(Label='mhvw')
{
};

//========================================================================================
// resource RDrawFrame(kDrawView)
//========================================================================================
// See constants in "FWViews.k", macros & resource types in "FWViews.fr"

// Reference size for the Draw frame (will be adjusted at runtime)
#define H 	FW_FIX(1000)
#define H1 	H + FW_FIX(1)

// Drawing extent (constants defined in Defines.k to be used also in .cpp files)
#define X	FW_FIX(kDrawingSizeX)
#define Y	FW_FIX(kDrawingSizeY)

resource FW_RFrameLayout(kMacHackView)
{
	{H,H},					// LayoutSize
	{						// Start list of frame's subviews
		RMacHackView
		(
			kMacHackViewID,					// View id
			{0, 0, H-FW_SBSIZE, H-FW_SBSIZE},	// Bounds
			FW_kFitToEnclosure,					// bindings
			{X,Y},								// extent
			1,									// Make it the ContentView
			FW_kXYScrolling,					// scrolling in both directions
			{
				FW_RButton
				(
					kNextID,						// view id
					{ FW_FIX(160),FW_FIX(170),FW_FIX(220),FW_FIX(190)},
					FW_kFixedBounds,				// binding
					FW_kButtonPressedMsg,			// control message
					FW_kViewReceiver,				// receiver
					0,								// control value
					FW_kPushButton,					// button kind
					FW_SYSTEM_FONT,
					"Next"			
				)
			}
		),
		FW_RScrollBar			// Horizontal SB
		(
			kHorzScrollBarID,					// View id
			{-FW_ONE, H-FW_SBSIZE, H1-FW_SBSIZE, H1},// Bounds
			FW_kHScrollBarBinding,				// Standard horizontal SB bindings
			0,									// control message
			0,									// control receiver
			0,									// control value
			0,									// SB Min Value (adjusted at runtime)
			1,									// SB Max Value (adjusted at runtime)
			FW_ONE,								// SB Minor Units (adjusted at runtime)
			FW_ONE								// SB Major Units (adjusted at runtime)
		),
		FW_RScrollBar			// Vertical SB
		(
			kVertScrollBarID,					// View id
			{H-FW_SBSIZE,-FW_ONE, H1, H1-FW_SBSIZE},// Bounds
			FW_kVScrollBarBinding,				// Standard vertical SB binding
			0,									// control message
			0,									// control receiver
			0,									// control value
			0,									// SB Min Value (adjusted at runtime)
			1,									// SB Max Value (adjusted at runtime)
			FW_ONE,								// SB Minor Units (adjusted at runtime)
			FW_ONE								// SB Major Units (adjusted at runtime)
		),
		FW_RGrowBox
		(
			kGrowBoxID,							// View id
			{H - FW_SBSIZE, H - FW_SBSIZE, H1, H1},	// Bounds
			FW_kGrowBoxBinding					// standard grow box binding
		)
	},
	{							// Scroller
		FW_RScrollBarScroller
		(
			FW_FIX(15),							// AutoScrollInset
			{FW_FIX(20), FW_FIX(20)}			// AutoScrollIncrement
			kHorzScrollBarID,					// horiz sb id
			kVertScrollBarID					// vertical sb id
		)
	}
};

