/******************************************************************************
 CMoviePano.h

				Header for CMoviePano Panorama/EditText Class
	
	Copyright  1996 Symantec Corp. and Glenn L. Austin. All rights reserved.

	Generated by Visual Architect 9:37 AM Wed, Jun 12, 1996

	This file is only generated once. You can modify it by filling
	in the placeholder functions and adding any new functions you wish.

	If you change the name of the document class, a fresh version of this
	file will be generated. If you have made any changes to the file
	with the old name, you will have to copy those changes to the new
	file by hand.

 ******************************************************************************/

#pragma once

#include "x_CMoviePano.h"

#include <Movies.h>
#include <CChore.h>

class CMovieChore;

class CMoviePano : public x_CMoviePano
{
public:

	TCL_DECLARE_CLASS

	CMoviePano();
	CMoviePano(CView *anEnclosure, CBureaucrat *aSupervisor,
					short aWidth = 0, short aHeight = 0,
					short aHEncl = 0, short aVEncl = 0,
					SizingOption aHSizing = sizELASTIC,
					SizingOption aVSizing = sizELASTIC);
	virtual ~CMoviePano();

	void				SetMovie(FSSpecPtr movieFileFSSpec);
	
	virtual void		Draw(Rect*);
	virtual void		DoClick(Point hitPt, short modifiers, long when);
	virtual void		ChangeSize(Rect* delta, Boolean redraw);
	    
    Movie				GetMovie(void) { return theMovie; }
    MovieController		GetController(void) { return theController; }

                                    /** Object I/O **/
    virtual void        PutTo(CStream &aStream);
    virtual void        GetFrom(CStream &aStream);
    
protected:
	Movie				theMovie;
	MovieController		theController;
	CMovieChore*		movieChore;
	FSSpec				theMovieFSS;
	
	void				IXCMoviePano(void);
	
private:
	static long			numMovies;
};

class CMovieChore : public CChore {
public:
	CMovieChore(CMoviePano*);
	virtual ~CMovieChore();
	
	virtual void		Perform(long *maxSleep);

protected:
	CMoviePano*			theMoviePano;
	Boolean				idling;
};
