/******************************************************************************
 CGXPano.cp

				CGXPano Panorama/EditText Class
	
	Copyright  1995 My Software Inc. All rights reserved.

	Generated by Visual Architect 4:16 PM Wed, Dec 13, 1995

	This file is only generated once. You can modify it by filling
	in the placeholder functions and adding any new functions you wish.

	If you change the name of the document class, a fresh version of this
	file will be generated. If you have made any changes to the file
	with the old name, you will have to copy those changes to the new
	file by hand.

 ******************************************************************************/

#include "CGXPano.h"

#include <Commands.h>
//#include "AppCommands.h"		// Uncomment to include VA-defined commands
//#include "graphics libraries.h"

TCL_DEFINE_CLASS_D1(CGXPano, x_CGXPano);

/**** C O N S T R U C T I O N / D E S T R U C T I O N   M E T H O D S ****/

CGXPano::CGXPano()
{
	aGXPort = nil;
	thePicture = nil;
	paneBounds = nil;
	memset(&animationWorld, 0, sizeof(animationWorld));
	memset(&animationWorldBackground, 0, sizeof(animationWorldBackground));
}

CGXPano::CGXPano(CView *anEnclosure, CBureaucrat *aSupervisor,
							short aWidth, short aHeight,
							short aHEncl, short aVEncl,
							SizingOption aHSizing,
							SizingOption aVSizing)
{
	IPanorama(anEnclosure, aSupervisor, aWidth, aHeight, aHEncl, aVEncl,
			aHSizing, aVSizing);
	
	aGXPort = nil;
	thePicture = nil;
	paneBounds = nil;
	memset(&animationWorld, 0, sizeof(animationWorld));
	memset(&animationWorldBackground, 0, sizeof(animationWorldBackground));
	
	CGXPanoX();
}

CGXPano::~CGXPano()
{
	DisposeCommonColors();
	
	if (thePicture)
		GXDisposeShape(thePicture);
	
	if (paneBounds)
		GXDisposeShape(paneBounds);
	
	DisposeOffscreen(&animationWorld);
	DisposeOffscreen(&animationWorldBackground);
	
	if (aGXPort)
		GXDisposeViewPort(aGXPort);
	
	// check if there are any more viewPorts in this window's viewPort
	aGXPort = GXGetWindowViewPort(GetMacPort());
	
	if (!GXGetViewPortChildren(aGXPort, nil))		// no more children?
		GXDisposeViewPort(aGXPort);
}

void CGXPano::IViewTemp(CView *anEnclosure, CBureaucrat *aSupervisor,
				Ptr viewData)
{
	x_CGXPano::IViewTemp(anEnclosure, aSupervisor, viewData);
	CGXPanoX();
}

void CGXPano::CGXPanoX(void)
{
	LongRect	frame;
	Rect		r;
	
	GetFrame(&frame);
	
	if (GetMacPort())
	{
		FrameToWindR(&frame, &r);
		
		// See if there is already a viewPort for this window...
		gxViewPort	windowPort = GXGetWindowViewPort(GetMacPort());
		
		if (!windowPort)
		{
			// no viewPort yet, so create one!
			windowPort = GXNewWindowViewPort(GetMacPort());
		}
		
		SetDefaultViewPort(windowPort);

		// create the viewPort for this pane
		aGXPort = GXNewViewPort(gxScreenViewDevices);
		GXSetViewPortParent(aGXPort, windowPort);
		
		// Adjust the viewPort's coordinates to match those of the pane's
	  	gxRectangle	viewBox;
		
		viewBox.left  = ff(r.left);
		viewBox.top = ff(r.top);
		viewBox.right = ff(r.right);
		viewBox.bottom = ff(r.bottom);
		
		gxShape			viewPortShape = GXNewRectangle(&viewBox);
		
		GXSetViewPortClip(aGXPort, viewPortShape);
		GXSetViewPortMapping(aGXPort, nil);
		
		SetDefaultViewPort(aGXPort);
		
		// OK, now the GX stuff should be based off of the top-left of this viewPort
		OffsetRect(&r, -r.left, -r.top);
		
		long		wid = frame.right - frame.left;
		long		ht = frame.bottom - frame.top;
		short		diam = ((wid < ht) ? wid : ht) / 3;
		gxRectangle	rectGeometry;
		gxColor		rgbColor;
		gxShape		myCircle, tempCircle;
		
		rectGeometry.top = ff(r.top);
		rectGeometry.left = ff(r.left);
		rectGeometry.bottom = ff(r.bottom);
		rectGeometry.right = ff(r.right);
		
		paneBounds = GXNewRectangle(&rectGeometry);
		SetShapeCommonColor(paneBounds, gxBlack);
		GXSetShapeHitTest(paneBounds, gxNoPart, 0);
		GXSetShapeViewPorts(paneBounds, 1, &aGXPort);
		
		thePicture = GXNewShape(gxPictureType);
		GXSetShapeViewPorts(thePicture, 1, &aGXPort);
		
		GXSetPictureParts(thePicture, 0, 0, 1, &paneBounds, nil, nil, nil);
		
		rgbColor.space = gxRGBSpace;
		rgbColor.profile = nil;
		rgbColor.element.rgb.red = 0xffff;	
		rgbColor.element.rgb.green = 0x0000; 	
		rgbColor.element.rgb.blue = 0x0000;
		
		gxRectangle	circleGeometry = {ff(r.left), ff(r.top),
							ff(r.left + diam), ff(r.top + diam)};
		
		// Create the red circle
		myCircle = NewOval(&circleGeometry);
		rgbColor.element.rgb.red = 0xffff;	
		rgbColor.element.rgb.green = 0x0000; 	
		rgbColor.element.rgb.blue = 0x0000;
		GXSetShapeColor(myCircle, &rgbColor);
		SetShapeCommonTransfer(myCircle, gxAddMode);
		GXSetShapeHitTest(myCircle, gxGeometryPart, ff(1));
		GXSetPictureParts(thePicture, 0, 0, 1, &myCircle, nil, nil, nil);
		
		// Create the green circle
		tempCircle = GXCopyToShape(nil, myCircle);
		GXDisposeShape(myCircle);
		rgbColor.element.rgb.red = 0x0000;	
		rgbColor.element.rgb.green = 0xffff; 	
		//rgbColor.element.rgb.blue = 0x0000;
		GXSetShapeColor(tempCircle, &rgbColor);
		GXMoveShape(tempCircle, 0, ff(diam));
		GXSetPictureParts(thePicture, 0, 0, 1, &tempCircle, nil, nil, nil);
		
		// Create the blue circle
		myCircle = GXCopyToShape(nil, tempCircle);
		GXDisposeShape(tempCircle);
		//rgbColor.element.rgb.red = 0x0000;	
		rgbColor.element.rgb.green = 0x0000; 	
		rgbColor.element.rgb.blue = 0xffff;
		GXSetShapeColor(myCircle, &rgbColor);
		GXMoveShape(myCircle, 0, ff(diam));
		GXSetPictureParts(thePicture, 0, 0, 1, &myCircle, nil, nil, nil);
		
		GXDisposeShape(myCircle);
		
		CTabHandle 	standardClut = GetCTable(72);
		gxColorSet	setOfColors = CTableToColorSet(standardClut);
		DisposeCTable(standardClut);
		
		gxBitmap    	baseMap;
		baseMap.image		= nil;
		baseMap.width 		= r.right - r.left;
		baseMap.height 		= r.bottom - r.top;
		baseMap.rowBytes 	= 0;
		baseMap.pixelSize 	= 8;
		baseMap.space 		= gxIndexedSpace;
		baseMap.set 		= setOfColors;
		baseMap.profile 	= nil;
		
		gxPoint     	mapPos;
		mapPos.x = mapPos.y = 0;
		
		gxShape		baseBits = GXNewBitmap(&baseMap, &mapPos);
		CreateOffscreen(&animationWorld, baseBits);
		GXDisposeShape(baseBits);
		
		baseBits = GXNewBitmap(&baseMap, &mapPos);
		CreateOffscreen(&animationWorldBackground, baseBits);
		GXDisposeShape(baseBits);
		GXDisposeColorSet(setOfColors);
		
		baseBits = GXCopyToShape(nil, paneBounds);
		SetShapeCommonColor(baseBits, gxWhite);
		GXSetShapeTransform(baseBits, animationWorldBackground.xform);
		GXDrawShape(baseBits);
		GXDisposeShape(baseBits);
		
		GXGetShapeTransform(animationWorldBackground.draw);
		GXSetShapeTransform(animationWorldBackground.draw, animationWorld.xform);
	}
}

/******************************************************************************
 DoCommand {OVERRIDE}

		Add code to this class to handle commands
 ******************************************************************************/

void CGXPano::DoCommand(long theCommand)

{
	// Below is the generic command handler for factored classes
	
	// If your class is factored for Apple event recording,
	// you will have to change the CGXPano.h file to additionally
	// derive from "public CAEObject" and add command handling
	// like the following. Each command case factored should
	// *return*, not break, so commands not handled by factoring
	// will fall through.

/*	Remove comment brackets if factored

	if (Factor())
	{
		if (theCommand < 0)
		{
			if (HiShort(-theCommand) == MENUfactored)
			{
				switch (LoShort(-theCommand))
				{
					case 1:					// item 1
						DoSomething1();
						return;
				}
		}
		else switch (theCommand)
		{
			cmdFactoredCmd:
				DoSomething();
				return;
		}
	}
*/

	// Below is the generic command handler for non-factored classes

	if (theCommand < 0)						// Respond to MENU items w/o commands
	{
		// replace if (FALSE) with your own test (see above)
		//
		// HiShort(-theCommand) has the MENU ID and
		// LoShort(-theCommand) has the item number

		if (FALSE)
		{
		}
		else
			x_CGXPano::DoCommand(theCommand);
	}
	else
	{
		switch (theCommand)
		{
			// insert your command cases here

			default:
				x_CGXPano::DoCommand(theCommand);
		}
	}
}


/******************************************************************************
 PutTo

        Put the contents of this object to the stream
 ******************************************************************************/

void	CGXPano::PutTo(
    CStream     &aStream)
{
		// Put any additional data members for this class
		// before calling the superclass PutTo.

		// If you have no additional data members, the
		// PutTo and GetFrom functions can be eliminated.

	x_CGXPano::PutTo(aStream);		/* Let superclass save				*/
	
		// By convention, any subordinate objects are put
		// after the superclass has had a chance to write
		// its instance variables.
}


/******************************************************************************
 GetFrom

        Get the contents of this object from the stream and
        initialize the object
 ******************************************************************************/

void	CGXPano::GetFrom(
    CStream     &aStream)
{
		// Get any additional data members for this class
		// before calling the superclass GetFrom


										/* Let superclass restore			*/
	x_CGXPano::GetFrom(aStream);

		// Restore any subordinate objects below
		
	CGXPanoX();
}

void CGXPano::Draw(Rect *area)
{
	if (thePicture)
		GXDrawShape(thePicture);
}

void CGXPano::DoClick(Point hitPt, short modifiers, long when)
{
	gxPoint			orgMouseLoc;
	gxHitTestInfo	test;
	gxShape			hit;
	CWindow*		myWindow = TCL_MacToTCLWindow(GetMacPort());
	
	Prepare();
	LocalToGlobal(&hitPt);
	
	GXConvertQDPoint(&hitPt, aGXPort, &orgMouseLoc);
	
	if (GXHitTestPicture(thePicture, &orgMouseLoc, &test, 1, 1))
	{
		if (StillDown())
		{	  	 
			gxShape		pageShape, tempShape;
			gxPoint 	newMouseLoc;
			Point		currMouseLoc;
	  	      
	  	      	//
	  	      	//	Get the shape hit by the user from the picture.
	  	      	//
			hit = GetPictureItem(test.containerPicture, test.containerIndex, nil, nil,
					nil, nil);
			GXSetShapeTransform(hit, animationWorld.xform);

			//
			// 	Remove the hit shape from the picture and redraw it.
			//
			pageShape = GXCopyToShape(nil,  test.containerPicture);
			tempShape = ExtractShape(pageShape, test.containerIndex, 1); 
			GXDisposeShape(tempShape);
			
			GXSetShapeTransform( pageShape, animationWorldBackground.xform );
			GXDrawShape ( pageShape );


			while (WaitMouseUp()) 
			{
				//
				//	Update the mouse location after the user has moved it. How? Get the mouse location from
				//	the Quickdraw based toolbox with the GetMouse function. We need to convert the QD point into a 
				//	fixed gxPoint, referring to the viewPort the mouse is located.
				//
				GetMouse(&hitPt);
				LocalToGlobal(&hitPt);
				GXConvertQDPoint(&hitPt, aGXPort, &newMouseLoc);
	
				//
				//	As the user drags a circle, we update the background of the window by drawing the contents
				//	of our GX off screen world containing the background of the window by calling
				//	GXDrawShape(gAnimationWorldBackGround.draw). We move the circle (i.e. hit) the user is dragging
				//	and redraw it. Finally, we update the contents of the window, thereby redrawing the area the
				//	user has messed up during the drag and update the location of the mouse.
				//
				if ((newMouseLoc.x != orgMouseLoc.x) || (newMouseLoc.y != newMouseLoc.y))     // has the mouse moved??
				{
					GXDrawShape(animationWorldBackground.draw);
	
	 				GXMoveShape (hit, newMouseLoc.x - orgMouseLoc.x,
	 						newMouseLoc.y - orgMouseLoc.y);
					GXDrawShape(hit);
	
				 	GXDrawShape(animationWorld.draw);
	     		
				 	orgMouseLoc = newMouseLoc;
				 }
			 }
		 	
		  GXDisposeShape(pageShape);
		}
	}
}
