
/*
	File:		PictureLibrary.c

	Contains:	graphics libraries - picture library
	
	Written by:	Cary Clark, Georgiann Delaney, Michael Fairman, Dave Good, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink, Chris Yerga
	
	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	  1/9/95	JD		First checked in.
*/

#include "GraphicsLibraries.h"
#include <GXMath.h>


void AddToPicture(gxShape picture, gxShape newShape, gxStyle newStyle, gxInk newInk, gxTransform newTransform)
{
    GXSetPictureParts(picture, 0, 0, 1, &newShape, &newStyle, &newInk, &newTransform);
}

void InsertPictureItem(gxShape picture, long index, gxShape newShape, gxStyle newStyle, gxInk newInk, gxTransform newTransform)
{
    GXSetPictureParts(picture, index, 0, 1, &newShape, &newStyle, &newInk, &newTransform);
}

gxShape GetPictureItem(gxShape picture, long index, gxShape *destShape, gxStyle *destStyle, gxInk *destInk, gxTransform *destTransform)
{
    gxShape tempShape;

    if( destShape == nil )
        destShape = &tempShape;

    if( GXGetPictureParts(picture, index, 1, destShape, destStyle, destInk, destTransform) )
        return *destShape;

    return nil;
}

void SetPictureItem(gxShape picture, long index, gxShape newShape, gxStyle newStyle, gxInk newInk, gxTransform newTransform)
{
    GXSetPictureParts(picture, index, 1, 1, &newShape, &newStyle, &newInk, &newTransform);
}
