
/*
	File:		QDLibrary.h
	
	Contains:	quickdraw library interfaces
	
	Written By:	Cary Clark, Michael Fairman, Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink
	
	Copyright:	1992-1995 by Apple Computer, Inc.  All rights reserved.
	
	Change History (most recent first):
	
		 <1>	  1/9/95	JD		First checked in.

*/

#ifndef __QDLIBRARY__
#define __QDLIBRARY__

#include <Icons.h>
#include <Quickdraw.h>
#include <GXTypes.h>

#ifdef __cplusplus
extern "C" {
#endif

/* for compatibility with old headers */
#define qdLibraryIncludes

/* geometry conversions */
gxPoint *ShortPointToFixed(const Point *, gxPoint *);
Point *FixedPointToShort(const gxPoint *, Point *);
gxRectangle *ShortRectToFixed(const Rect *, gxRectangle *);
Rect *FixedRectToShort(const gxRectangle *, Rect *);

/* gxColor conversions */
gxColorSet CTableToColorSet(const CTabHandle);
CTabHandle ColorSetToCTable(const gxColorSet);

/* pixmap/gxBitmap conversions */
gxBitmap *ConvertFromQDBitmap(const BitMap *, gxBitmap *);
BitMap *ConvertToQDBitmap(const gxBitmap *, BitMap *);
gxShape BitMapToShape(const BitMap *);
gxShape PixMapToShape(const PixMapHandle);
gxShape GetPixMapShape(short resourceID);
gxShape CICNToMask(CIconHandle iconH);
gxShape CICNToShape(CIconHandle iconH);
gxShape GetCICNMask(long resourceID);
gxShape GetCICNShape(long resourceID);

#ifdef __cplusplus
}
#endif

#endif /* __QDLIBRARY__ */
