#include "MP GrafLib Support.h"
#include "LowMem.h"

Ptr GetIndVideoBaseAddress(unsigned int Display)
{
	RegEntryIter			RegistryEntryIterator;
	RegEntryID				RegistryEntry;
	RegEntryIterationOp		RegistryEntryIteratorOperator = kRegIterRoot;
	Boolean					IterateDone = FALSE;
	OSStatus				theError = 0;
	long					DelayTime = 0;
	Ptr						AddressValue = NULL;
	unsigned long			AddressValueSize = 4;
	unsigned int			IndexCounter = 0;

	RegistryEntryIDInit(&RegistryEntry);
	theError = RegistryEntryIterateCreate(&RegistryEntryIterator);
	if(!theError)
	{
		while(!IterateDone && !theError)
		{
			theError = RegistryEntrySearch(&RegistryEntryIterator, RegistryEntryIteratorOperator, &RegistryEntry, 
											&IterateDone, "device_type", "display", 8);
			if (!IterateDone && !theError)
			{
				if(IndexCounter == Display)
				{
					RegistryPropertyGet(&RegistryEntry, "AAPL,address", &AddressValue, &AddressValueSize);
					IterateDone = TRUE;
				}
				else
				{
					IndexCounter++;
				}

				RegistryEntryIDDispose(&RegistryEntry);
			}
			RegistryEntryIteratorOperator = kRegIterContinue;
		}
	}

	RegistryEntryIterateDispose(&RegistryEntryIterator);

	if(theError)
	{
		return(NULL);
	}
	else
	{
		return(AddressValue);
	}
}

	
OSErr RetreiveVideoParameters(Ptr BaseAddress, unsigned int *resX, unsigned int *resY, unsigned int *BitDepth)
{
/*	There seems to be an inconsistancy between the information
	documented in the "Designing Drivers for PCI Systems" book
	and the actual implementation of many graphics cards. Either
	the cards do not report their current status in the depth, width
	and height properties, or they do not even have the properties at
	all!
	
	RegEntryIter			RegistryEntryIterator;
	RegEntryID				RegistryEntry;
	RegEntryIterationOp		RegistryEntryIteratorOperator = kRegIterRoot;
	Boolean					IterateDone = FALSE;
	OSStatus				theError = 0;
	long					DelayTime = 0;
	Ptr						AddressValue = NULL;
	unsigned long			AddressValueSize = 4;
	unsigned int			IndexCounter = 0;

	RegistryEntryIDInit(&RegistryEntry);
	theError = RegistryEntryIterateCreate(&RegistryEntryIterator);
	if(!theError)
	{
		while(!IterateDone && !theError)
		{
			theError = RegistryEntrySearch(&RegistryEntryIterator, RegistryEntryIteratorOperator, &RegistryEntry, 
											&IterateDone, "device_type", "display", 8);
			if (!IterateDone && !theError)
			{
				RegistryPropertyGet(&RegistryEntry, "AAPL,address", &AddressValue, &AddressValueSize);
				if(AddressValue == BaseAddress)
				{
					RegistryPropertyGet(&RegistryEntry, "width", resX, &AddressValueSize);
					RegistryPropertyGet(&RegistryEntry, "height", resY, &AddressValueSize);
					RegistryPropertyGet(&RegistryEntry, "depth", BitDepth, &AddressValueSize);
	
					IterateDone = TRUE;
				}

				RegistryEntryIDDispose(&RegistryEntry);
			}
			RegistryEntryIteratorOperator = kRegIterContinue;
		}
	}

	RegistryEntryIterateDispose(&RegistryEntryIterator);

*/

	// Using QuickDraw instad to determine display paramaters
	
	GDHandle	theDevice = GetDeviceList();
	Boolean		Found = FALSE;
	Boolean		Done = FALSE;

	// Search through all attatched devices
	while(Done == FALSE && Found == FALSE)
	{
		// Check to match the device with the Name Registry retreived address
		// Note that 0x00800000 has to be subtracted. May be different pages??
		if((*(*theDevice)->gdPMap)->baseAddr - 0x00800000 == BaseAddress &&
			(*theDevice)->gdType == 2)
		{
			// Device is direct!
			Found = TRUE;
		
			// Set informaiton
			*resX = (*(*theDevice)->gdPMap)->bounds.right - (*(*theDevice)->gdPMap)->bounds.left;
			*resY = (*(*theDevice)->gdPMap)->bounds.bottom - (*(*theDevice)->gdPMap)->bounds.top;
			*BitDepth = (*(*theDevice)->gdPMap)->pixelSize;
		}
		else
		{
			if((*theDevice)->gdNextGD == NULL)
			{
				Done = TRUE;
			}
			else
			{
				theDevice = (GDHandle) (*theDevice)->gdNextGD;
			}
		}
	}
	
	if(Found == FALSE)
	{
		// Nothing found, return error
		*resX = 0;
		*resY = 0;
		*BitDepth = 0;

		return(10);
	}
	else
	{
		return(noErr);
	}
}
