//------------------------------------------------------------------------------------------
// COPYRIGHT  1997, David Slik. All Rights Reserved
//------------------------------------------------------------------------------------------
// Contents		: MP Internal Routines							(MP GrafLib Internals.c)
// Version      : 1.0
// Last Updated	: May 21, 1997
// Written By	: David Slik
//------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------
// DISCLAIMER - The author is not responsible for the results of using this code
//------------------------------------------------------------------------------------------
// If you find any bugs in this source code, please email me and I will attempt to fix
// them.  If you have any additions, modifications or suggestions, please let me know.
// I can be reached at the following address: dslik@paradata.com
// Updates will be posted to the URL http://www.paradata.com/~dslik/MPGL/MPGL.html
//
// Permission to use and modify this code is freely granted to all users.
//------------------------------------------------------------------------------------------


// HEADER FILES	---------------------------------------------------------------------

#include "MP GrafLib Internals.h"


// FUNCTIONS	---------------------------------------------------------------------


//------------------------------------------------------------------------------------------
// Thread Safe		: [x]	| Normal Build		: [x]	| Posts Events	: [ ]
// Reentrant		: [ ]	| Debug Build		: [ ]	| Pulls Events	: [ ]
// MP Compatable	: [x]	| Structure Checking: [ ]	+-----------------------------------
//--------------------------+---------------------------+ Performance Critical	: [ ]
// Allocates Memory	: [ ]	| Calls Functions	: [ ]	| Performance : L [x] M [ ] H [ ]
// Moves Memory		: [ ]	| Calls Toolbox		: [ ]	| Normal Overhead	: ???
// Uses TB Memory 	: [ ]	| Calls QuickDraw	: [ ]	| Debug Overhead	: ???
// Uses PAM Memory	: [ ]	| Async Callback	: [ ]	| MP Overhead		: ???
//------------------------------------------------------------------------------------------
// Function Name		: DS_isEnvironmentSetup
// Function Description	: Checks to make sure that the library is initilized.
// Error Checking		: Forms error checking for most functions
// Last Updated			: May 21, 1997
// Written By			: David Slik
// Modifications		:
// Notes				: 
//------------------------------------------------------------------------------------------
Boolean DS_isEnvironmentSetup(void)
{
	// Check to see if the InitCheck field is
	// set to the expected value
	if(gDSGlobals.InitCheck == INITCHECK_VALUE)
	{
		// Correct value found, Therefore initilized
		return(true);
	}
	else
	{
		// Incorrect value found, Not initilized.
		return(false);
	}
}

