//------------------------------------------------------------------------------------------
// COPYRIGHT  1997, David Slik. All Rights Reserved
//------------------------------------------------------------------------------------------
// Contents		: Public MP GrafLib Functions							(MP GrafLib.h)
// Last Updated	: May 25, 1997
// Written By	: David Slik
//------------------------------------------------------------------------------------------

//------------------------------------------------------------------------------------------
// DISCLAIMER - The author is not responsible for the results of using this code
//------------------------------------------------------------------------------------------
// If you find any bugs in this source code, please email me and I will attempt to fix
// them.  If you have any additions, modifications or suggestions, please let me know.
// I can be reached at the following address: dslik@paradata.com
// Updates will be posted to the URL http://www.paradata.com/~dslik/MPGL/MPGL.html
//
// Permission to use and modify this code is freely granted to all users.
//------------------------------------------------------------------------------------------


// HEADER FILES	---------------------------------------------------------------------

// STRUCTURES	---------------------------------------------------------------------

typedef struct
{
	short	left;
	short	top;
	short	right;
	short	bottom;
} DS_Rect;

typedef struct
{
	Ptr				BaseAddress;
	unsigned int	BitDepth;
	unsigned int	HRes;
	unsigned int	VRes;
} GrafParams;

typedef unsigned int DS_RGBColor;

// DEFINES		---------------------------------------------------------------------

#define		ERROR_NONE					0
#define		ERROR_NOT_INIT			10000
#define		ERROR_IS_INIT			10001
#define		ERROR_INVALID_CLIPPING	10005


// PROTOTYPES	---------------------------------------------------------------------


// MP GrafLib Initilization
OSErr InitMPGrafLib(Ptr BaseAddress, short BitDepth, short HRes, short VRes);
OSErr DeInitMPGrafLib(void);
OSErr SetClippingRect(DS_Rect theClippingRect);


// MP GrafLib Color Routines
DS_RGBColor DS_SetColor(unsigned char Red, unsigned char Green, unsigned char Blue);
DS_RGBColor DS_GetForeColor(void);
DS_RGBColor DS_GetBackColor(void);
void DS_SetForeColor(DS_RGBColor theColor);
void DS_SetBackColor(DS_RGBColor theColor);
unsigned int DS_GetBitDepth(void);


// MP GrafLib Drawing Routines
void DS_MoveTo(short horiz, short vert);
void DS_LineTo(short horiz, short vert);
void DS_Line(short distHoriz, short distVert);
void DS_FrameRect(DS_Rect *theRect);
void DS_FillRect(DS_Rect *theRect);
void DS_SetPixel(short xCooridinate, short yCooridinate, unsigned int PixelValue);


// MP GrafLib Utility Routines
void DS_SetRect(DS_Rect *theRect, short rLeft, short rTop, short rRight, short rBottom);
void DS_OffsetRect(DS_Rect *theRect, short distHoriz, short distVert);
void DS_InsetRect(DS_Rect *theRect, short distHoriz, short distVert);
Boolean DS_RectInRect(DS_Rect *theRect, DS_Rect *InsideRect);
