/****************************************************************************************
	XThreadsQueue.h

	Copyright  1997 United Software Express. All rights reserved.

	Commenter	Date				Comment
	---------	-----------------	-----------------------------------------------------
	wolfie		Mon, Mar 3, 1997	Created.
	
****************************************************************************************/

#ifndef		__XThreadsQueue__
#define		__XThreadsQueue__

#include	"XThreads.h"

/*
 *
 *	Types
 *
 */

typedef	struct XThreadElem	XThreadElem, *XThreadElemPtr, **XThreadElemHandle;
typedef	struct XThreadQueue	XThreadQueue, *XThreadQueuePtr, **XThreadQueueHandle;

struct	XThreadElem {
	XThreadElemPtr	next;
	XThreadQueuePtr	queue;
	ThreadID		threadID;
};

struct XThreadQueue {
	short			type;
	XThreadElemPtr	head;
	XThreadElemPtr	tail;
	XThreadElemPtr	mark;
};

/*
 *
 *	Globals
 *
 */

extern	XThreadQueue	gUnassignedQueue, gIneligibleQueue, gEligibleQueue, gPriorityQueue;
extern	XThreadElemPtr	gCurrentThread;

/*
 *
 *	Interfaces
 *
 */

extern	XThreadElemPtr	NewThreadElem( ThreadID threadID );
extern	void			DisposeThreadElem( XThreadElemPtr threadElem );
extern	void			SetThreadElemQueue( XThreadElemPtr threadElem, XThreadQueuePtr threadQueue );
extern	XThreadElemPtr	GetNextThreadElemInQueue( XThreadQueuePtr threadQueue );
extern	XThreadElemPtr	GetThreadElemGivenThreadID( ThreadID threadID );

#endif