#ifndef __CONTEXTUALMENU__
#define __CONTEXTUALMENU__

#ifndef __APPLEEVENTS__
#include <AppleEvents.h>
#endif
#ifndef __EVENTS__
#include <Events.h>
#endif
#ifndef __MENUS__
#include <Menus.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import on
#endif

#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=mac68k
#endif


enum {
	_ContextualMenuDispatch		= 0xAA72						/* Contextual Menu Trap Number*/
};


enum {
																/* Gestalt Selectors */
	gestaltContextualMenuAttr	= 'cmnu',
	gestaltContextualMenuPresent = 0,
	gestaltContextualMenuTrapAvailable = 1
};


enum {
																/* Values indicating what kind of help the application supports */
	kCMHelpItemNoHelp			= 0,
	kCMHelpItemAppleGuide		= 1,
	kCMHelpItemOtherHelp		= 2,							/* Values indicating what was chosen from the menu */
	kCMNothingSelected			= 0,
	kCMMenuItemSelected			= 1,
	kCMShowBalloonSelected		= 2,
	kCMShowHelpSelected			= 3
};

extern pascal OSStatus InitContextualMenus(void )
 TWOWORDINLINE(0x7001, 0xAA72);

extern pascal Boolean IsShowContextualMenuClick(const EventRecord *inEvent)
 TWOWORDINLINE(0x7002, 0xAA72);

extern pascal OSStatus ContextualMenuSelect(MenuRef inMenuRef, Point inGlobalLocation, Boolean inBalloonAvailable, UInt32 inHelpType, ConstStr255Param inHelpItemString, const AEDesc *inSelection, UInt32 *outUserSelectionType, SInt16 *outMenuID, UInt16 *outMenuItem)
 TWOWORDINLINE(0x7003, 0xAA72);


#if PRAGMA_ALIGN_SUPPORTED
#pragma options align=reset
#endif

#if PRAGMA_IMPORT_SUPPORTED
#pragma import off
#endif

#ifdef __cplusplus
}
#endif

#endif /* __CONTEXTUALMENU__ */

