/*
	File:		SampleCMPlugin.h

	Contains:	Sample Contextual Menu plugin header

	Written by:	Arno Gourdol

	Copyright:	1997, Apple Computer, Inc. All rights reserved.

*/


#pragma once


// Parent Class Include
#include <AbstractCMPlugin.h>


class SampleCMPlugin : virtual AbstractCMPlugin {

#pragma SOMReleaseOrder (	Initialize, \
							ExamineContext, \
							HandleSelection, \
							PostMenuCleanup, \
							ProcessFileList)

public:

	virtual	OSStatus Initialize(
							Environment*,
							FSSpec *inFileSpec);
	virtual	OSStatus ExamineContext(
							Environment*,
							AEDesc* inContextDescriptor,
							SInt32 inTimeOutInTicks,
							AEDescList* ioCommands,
							Boolean* outNeedMoreTime);
	virtual	OSStatus HandleSelection(
							Environment*,
							AEDesc* inContextDescriptor,
							SInt32 inCommandID);
	virtual	OSStatus PostMenuCleanup(
							Environment*);

	void ProcessFileList(
							Environment*,
							AEDescList* fileList, 
							SInt32 commandID);

private:
	FSSpec fPluginFile;
	UInt32 fSelectionCount;
};

