/**********************************************************************************
	FILE: IPLSBrowserConfig.cp
	Description: Our Preferences structure, and the routines that read/write the
		prefs and allow the user to configure them.
		
		Not an example of good programming.  Uses a string constant for the prefs
		file name, so it would have localization problems.

	1997, CE Software, Inc.  All rights reserved.
	P.O. Box 65580
	West Des Moines, Iowa 50265 U.S.A.

***********************************************************************************/

#include "IPLSBrowserConfig.h"

ServerEntry gServerEntries[8];
FSSpec		gPrefsSpec;	//the file to put our prefs in

ServerEntry	tempServerEntries[8];

void InitServerList(void)
{
	//try to read in prefs
	OSErr	theerr;
	short	vref;
	long	dirID;
	short	refnum;
	long	count;
	short	index;
	
	for (index = 0; index<8; index++)
	{
		gServerEntries[index].ServerName[0] = 0;	//clear the name
		gServerEntries[index].ServerIPAddress[0] = 0;	//clear the name
		gServerEntries[index].ServerPassword[0] = 0;
	}
	
	
	theerr = FindFolder(kOnSystemDisk, kPreferencesFolderType, false, &vref, &dirID);
	theerr = FSMakeFSSpec(vref, dirID, "\pIPLS Browser Server List", &gPrefsSpec);
	theerr = FSpOpenDF(&gPrefsSpec, 0, &refnum);
	if (theerr==noErr)
	{
		count = sizeof(gServerEntries);
		theerr = FSRead(refnum, &count, &gServerEntries);
		theerr = FSClose(refnum);
	}
	else
	{
		if (!ConfigServerList())	//Initial configuration
			ExitToShell();
	}
}

static void BlinkButton(DialogPtr theDialog,
				short btnNumber)
{
	Handle				itemHandle;
	short				itemType;
	Rect				itemRect;
	long				ignoreLong;
	
	GetDItem(theDialog, btnNumber, &itemType, &itemHandle, &itemRect);
	HiliteControl((ControlHandle)itemHandle, true);
	Delay(7, &ignoreLong);
	HiliteControl((ControlHandle)itemHandle, false);
}

static void DoEnableButton(DialogPtr thedialog, short itemnum, Boolean theval)
{
	short	dtype;
	Handle	ditem;
	Rect	rview;

	GetDialogItem(thedialog,itemnum,&dtype,&ditem,&rview);
	if (theval)
	{
		HiliteControl((ControlHandle)ditem, 0);
	}
	else
	{
		HiliteControl((ControlHandle)ditem, 255);
	}
}

//
// Draw a single entry
//
static pascal void ServerDialogItem(DialogPtr thedialog, short itemnum)
{
	short	dtype;
	Handle	ditem;
	Rect	rview;
	short	whichserver = itemnum - 6;

	GetDialogItem(thedialog,itemnum,&dtype,&ditem,&rview);
	EraseRect(&rview);
	rview.right -= 1; rview.bottom -= 1;
	FrameRect(&rview);
	MoveTo(rview.left+1, rview.bottom);
		LineTo(rview.right, rview.bottom);
		LineTo(rview.right, rview.top+1);
	
	if (tempServerEntries[whichserver].ServerName[0])
	{
		MoveTo(rview.left+4, rview.bottom-6);
		TextFont(applFont); TextSize(9);
		DrawString(tempServerEntries[whichserver].ServerName);
		DrawString("\p (");
		
		DrawString(tempServerEntries[whichserver].ServerIPAddress);

		if (tempServerEntries[whichserver].ServerPassword[0])
		{
			DrawString("\p/****");
		}
		
		DrawString("\p)");
		TextFont(0); TextSize(9);
	}
}

static pascal void OutlineDialogItem(DialogPtr thedialog, short itemnum)
{
	short	dtype;
	Handle	ditem;
	Rect	rview;

	GetDialogItem(thedialog,itemnum,&dtype,&ditem,&rview);
	PenSize(2,2);
	FrameRoundRect(&rview, 16, 16);
	PenSize(1,1);
}

static pascal Boolean ConfigDialogEventFilter(DialogPtr pDialog,
									EventRecord *macEvent,
									short *itemHit)
	{
	#define kDelay			7
	
	short	itemType;
	ControlHandle	itemHandle;
	Rect	itemRect;
	Cell	thecell;

	switch (macEvent->what)
		{
		case keyDown:
		case autoKey:
			switch (macEvent->message & charCodeMask)
				{
				case 0x03:		// enter key
				case 0x0D:		// return key
					GetDItem(pDialog, 1, &itemType, &((Handle)itemHandle), &itemRect);
					if ((*itemHandle)->contrlHilite)
					{
						macEvent->what = 0;
						return	false;
					}
					else
					{
						BlinkButton(pDialog, 1);
						*itemHit = 1;
						return true;
					}
				case 0x1B:		// escape key
					BlinkButton(pDialog, 2);
					*itemHit = 2;
					return true;
				case '.':		//command-period
					if (macEvent->modifiers & cmdKey)
					{
						BlinkButton(pDialog, 2);
						*itemHit = 2;
						return true;
					}
				default:
					return false;
				}
			break; //of keydown
		default:
			return false;
		}
	}

static Boolean EditAnEntry(short whichentry)	//Edit one entry
{
	DialogPtr mydialog;
	short	dtype;
	Handle	ditem;
	Rect	rview;
	short	itemhit;
	
	Str255	tempstr;
	Str255	str2;

	ModalFilterUPP	OurFilterUPP;
	UserItemUPP	OurOvalUPP;
	
	mydialog=GetNewDialog(134,nil,(WindowPtr)-1);
	
	OurOvalUPP = NewUserItemProc(OutlineDialogItem);	//outline the OK button
	GetDialogItem(mydialog,15,&dtype,&ditem,&rview);
	SetDialogItem(mydialog,15,dtype,(Handle)OurOvalUPP,&rview);
	
	//put the entries up there
	GetDialogItem(mydialog,4,&dtype,&ditem,&rview);
	SetDialogItemText (ditem, tempServerEntries[whichentry].ServerName);

	GetDialogItem(mydialog,5,&dtype,&ditem,&rview);
	SetDialogItemText (ditem, tempServerEntries[whichentry].ServerIPAddress);

	GetDialogItem(mydialog,6,&dtype,&ditem,&rview);
	SetDialogItemText (ditem, tempServerEntries[whichentry].ServerPassword);
	
	NumToString(whichentry+1, tempstr);
	ParamText(tempstr, "\p", "\p", "\p");
	
	SelectDialogItemText (mydialog, 4, 0, 32767);
	
	// Just call ModalDialog with a simple filter for escape, command period, etc.
	OurFilterUPP = NewModalFilterProc(ConfigDialogEventFilter);
	InitCursor();
	do
	{
		GetDialogItem(mydialog,4,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, tempstr);

		GetDialogItem(mydialog,5,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, str2);

		//OK is only enabled if the there's a name and an address
		DoEnableButton(mydialog, 1,  (tempstr[0]>0) && (str2[0]>0));
		ModalDialog(OurFilterUPP, &itemhit);
	}
	while (itemhit>3);
	DisposeRoutineDescriptor(OurFilterUPP);
	
	if (itemhit==ok)
	{
		// Get the entry back
		GetDialogItem(mydialog,4,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, tempstr);
		if (tempstr[0]>31)
			tempstr[0] = 31;
		PLstrcpy(tempServerEntries[whichentry].ServerName, tempstr);

		GetDialogItem(mydialog,5,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, tempstr);
		if (tempstr[0]>63)
			tempstr[0] = 63;
		PLstrcpy(tempServerEntries[whichentry].ServerIPAddress, tempstr);

		GetDialogItem(mydialog,6,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, tempstr);
		if (tempstr[0]>15)
			tempstr[0] = 15;
		PLstrcpy(tempServerEntries[whichentry].ServerPassword, tempstr);
	}
	else if(itemhit==3)
	{
		tempServerEntries[whichentry].ServerName[0] = 0;
		tempServerEntries[whichentry].ServerIPAddress[0] = 0;
		tempServerEntries[whichentry].ServerPassword[0] = 0;
	}
	
	DisposeRoutineDescriptor(OurItemUPP);
	DisposeDialog(mydialog);
	
	return (itemhit==ok);

}


Boolean ConfigServerList(void)	//Let the user config the list of entries
{
	DialogPtr mydialog;
	short	dtype;
	Handle	ditem;
	Rect	rview;
	short	itemhit;
	
	Str255	tempstr;

	OSErr	theerr;
	short	refnum;
	long	count;
	
	short	index;
	
	ModalFilterUPP	OurFilterUPP;
	UserItemUPP	OurOvalUPP;
	UserItemUPP	OurServerItemUPP;
	
	mydialog=GetNewDialog(133,nil,(WindowPtr)-1);
	
	OurOvalUPP = NewUserItemProc(OutlineDialogItem);	//outline the OK button
	GetDialogItem(mydialog,5,&dtype,&ditem,&rview);
	SetDialogItem(mydialog,5,dtype,(Handle)OurOvalUPP,&rview);
	
	for (index = 0; index<8; index++)
	{
		tempServerEntries[index] = gServerEntries[index];
	}
	
	OurServerItemUPP = NewUserItemProc(ServerDialogItem);	//Draw the servers
	for (index = 0; index<8; index++)
	{
		GetDialogItem(mydialog,6+index,&dtype,&ditem,&rview);
		SetDialogItem(mydialog,6+index,dtype,(Handle)OurServerItemUPP,&rview);
	}
	
	// Just call ModalDialog with a simple filter for escape, command period, etc.
	OurFilterUPP = NewModalFilterProc(ConfigDialogEventFilter);
	InitCursor();
	
	//Immediately call Set Item 0 if it's not set
	if (!tempServerEntries[0].ServerIPAddress[0])
	{
		if (EditAnEntry(0))
		{
			SetPort(mydialog);
			ServerDialogItem(mydialog, 6);	//draw the newitem
		}
	}
	
	do
	{
		//OK is only enabled if the first entry exists
		DoEnableButton(mydialog, 1, 
			(tempServerEntries[0].ServerName[0]>0)
			&& (tempServerEntries[0].ServerIPAddress[0]>0));
		
		ModalDialog(OurFilterUPP, &itemhit);
		if ((itemhit>5)&&(itemhit<14))
		{
			if (EditAnEntry(itemhit-6))
			{
				SetPort(mydialog);
				ServerDialogItem(mydialog, itemhit);	//draw the server item
			}
		}
		if ((itemhit>13)&&(itemhit<22))
		{
			if (EditAnEntry(itemhit-14))
			{
				SetPort(mydialog);
				ServerDialogItem(mydialog, itemhit - 6);	//draw the server item
			}
		}
	}
	while (itemhit>2);
	DisposeRoutineDescriptor(OurFilterUPP);
	
	if (itemhit==ok)
	{
		for (index = 0; index<8; index++)
		{
			gServerEntries[index] = tempServerEntries[index];
		}

		theerr = FSpCreate(&gPrefsSpec, 'IPLS', 'DATA', smSystemScript);
		theerr = FSpOpenDF(&gPrefsSpec, 0, &refnum);
		if (theerr==noErr)
		{
			count = sizeof(gServerEntries);
			theerr = FSWrite(refnum, &count, &gServerEntries);
			theerr = FSClose(refnum);
		}
	}
	
	DisposeRoutineDescriptor(OurItemUPP);
	DisposeRoutineDescriptor(OurServerItemUPP);
	DisposeDialog(mydialog);
	
	return (itemhit==ok);

}

