/**********************************************************************************
	FILE: IPLSBrowserWindow.cp
	Description: Nothing too special with the IPLS protocol in here, just a
		window handler with the two lists, URL, etc.  The IPLS calling detail
		is in HandleIPLSCall.cp
		
		Not completely an example of good programming.  Uses many string constants,
		so it would have localization problems.  Does not check error conditions
		well.

	1997, CE Software, Inc.  All rights reserved.
	P.O. Box 65580
	West Des Moines, Iowa 50265 U.S.A.

***********************************************************************************/

#include <PLStringFuncs.h>		/* some special string handling stuff */

#include "IPLSBrowserWindow.h"
#include "HandleIPLSCall.h"
#include "IPLSBrowserConfig.h"
#include "IPLSBrowser.h"

enum	WhichIPLSButton	{	keUpdateButton, keURLButton	};
		
enum	WhichHilightEnum	{	keWHUpdate, keWHServices,keWHPersons, keWHURL	};

static ListHandle	gServiceList = nil;	//this is the list of services
static ListHandle	gPersonList = nil;	//this is the list of users
static Str255		gIPAddress;
static Str255		gIPPassword;
static Str255		gIPName;
static OSType		gServiceToLookup;
static Str255		gNameToLookup;
static Str255		gURL;

static short		gServerToShow = 0;
static WhichHilightEnum	gHighlightedItem = keWHUpdate;

static WindowPtr	gTheWindow = nil;

static Rect			gPortRect;

static Rect			gSLTitleRect;		//rects for Popup list of servers
static Rect			gSLMenuRect;
static Rect			gUpdateBtnRect;
static ControlHandle	gUpdateButton;

static Rect			gURLDisplayRect;	//URL launching stuff
static Rect			gURLBtnRect;
static ControlHandle	gURLButton;

static Rect			gServiceListRect;	//Rect of services
static Rect			gPeopleListRect;

static ListHandle BuildAList(Rect* therect)
{
	Rect	rview;
	Rect	dataBounds;
	Cell	cSize;
	ListHandle	templist;
	
	SetPort(gTheWindow);
	TextFont(0);
	TextSize(0);
	
	rview = *therect;
	InsetRect(&rview, 1, 1);
	rview.right = rview.right - 15; 
	dataBounds.top = 0;
	dataBounds.left = 0;
	dataBounds.right = 1;
	dataBounds.bottom = 0;
	cSize.v = 18;
	cSize.h = rview.right - rview.left;
	templist = LNew(&rview,&dataBounds,cSize,0,gTheWindow,false,false,false,true);
	(*templist)->selFlags = lUseSense+lNoExtend;
	return templist;
}

void InitIPLSBRWind( void )
{
	Rect	temprect;
	
	gTheWindow = GetNewWindow (128, nil, (WindowPtr)-1 );

	gNameToLookup[0] = 0;
	gURL[0] = 0;
	gServiceToLookup = 0;
	PLstrcpy( gIPName, gServerEntries[gServerToShow].ServerName);
	PLstrcpy( gIPAddress, gServerEntries[gServerToShow].ServerIPAddress);
	PLstrcpy( gIPPassword, gServerEntries[gServerToShow].ServerPassword);
	
	gPortRect = gTheWindow->portRect;
	
	temprect = gPortRect; temprect.bottom = temprect.top + 30;
	gSLTitleRect.top = temprect.top+7;
	gSLTitleRect.bottom = gSLTitleRect.top+20;
	gSLTitleRect.left = 5; gSLTitleRect.right = gSLTitleRect.left + 70;
	
	gSLMenuRect = gSLTitleRect;
	gSLMenuRect.left = gSLTitleRect.right+5; gSLMenuRect.right = gPortRect.right - 160;
	
	gUpdateBtnRect = gSLMenuRect;
	gUpdateBtnRect.left = gSLMenuRect.right+10; gUpdateBtnRect.right = gUpdateBtnRect.right +80;
	gUpdateButton = NewControl(gTheWindow, &gUpdateBtnRect, "\pUpdate", true, 0, 0, 1, 0, keUpdateButton);
	
	gURLDisplayRect.bottom = gPortRect.bottom - 5;		//create the URL rects
	gURLDisplayRect.top = gURLDisplayRect.bottom - 32;
	gURLDisplayRect.right = gPortRect.right - 5;
	gURLDisplayRect.left = gPortRect.left + 95;
	
	gURLBtnRect.left = gPortRect.left+10; gURLBtnRect.top = gURLDisplayRect.top;
	gURLBtnRect.right = gURLBtnRect.left + 80; gURLBtnRect.bottom = gURLBtnRect.top + 20;
	gURLButton = NewControl(gTheWindow, &gURLBtnRect, "\pURL", true, 0, 0, 1, 0, keURLButton);
	HiliteControl (gURLButton, 255);
	
	gServiceListRect.left = gPortRect.left + 10;
	gServiceListRect.right = (gPortRect.left+gPortRect.right)/2-5;
	gServiceListRect.top = gSLMenuRect.bottom+30;
	gServiceListRect.bottom = gURLDisplayRect.top - 10;
	
	gPeopleListRect = gServiceListRect;
	gPeopleListRect.left = gServiceListRect.right+10;
	gPeopleListRect.right = gPortRect.right-10;
	
	gServiceList = BuildAList(&gServiceListRect);
	gPersonList = BuildAList(&gPeopleListRect);

	LDoDraw(true,gServiceList);
	LDoDraw(true,gPersonList);
	ShowWindow(gTheWindow);
}

static void DrawPopUpMenuStuff(void)
{
	RgnHandle	temprgn;
	Rect		rview;
	Str255		tempstr = "\pServer:";
	
	TextFont(0); TextSize(0);
	rview = gSLTitleRect;	//draw the title
	InsetRect(&rview, 1, 1);
	TETextBox(&tempstr[1], tempstr[0], &rview, 0);
	
	rview = gSLMenuRect;	//draw the popup menu
	EraseRect(&rview);
	rview.right-=2;
	rview.bottom -=2;
	PenSize(2,2);
	MoveTo(rview.left+2, rview.bottom);
	LineTo(rview.right,rview.bottom);
	LineTo(rview.right, rview.top+2);
	PenSize(1,1);
	FrameRect(&rview);
	InsetRect(&rview, 1, 1);
	temprgn = NewRgn();
	OpenRgn();
	MoveTo(rview.right-2, rview.top+4);
	Line(-5, 5);
	Line(-5, -5);
	Line(10,0);
	CloseRgn(temprgn);
	PaintRgn(temprgn);
	DisposeRgn(temprgn);
	
	rview.right -= 12;
	TETextBox(&gIPName[1], gIPName[0], &rview, 0);

	TextFont(0);
	TextSize(0);
}

static void DrawURLStuff()
{
	Str255	nonestr = "\pNone";
	
	if (gURL[0])		//draw URL
	{
		TextFont(applFont);
		TextSize(12);
		TextFace(bold);
		TETextBox(&gURL[1],gURL[0], &gURLDisplayRect, 0);
	}
	else
	{
		TextFont(applFont);
		TextSize(9);
		TextFace(0);
		TETextBox(&nonestr[1],nonestr[0], &gURLDisplayRect, 0);
	}
	TextFace(0);
	TextFont(0);
	TextSize(0);
}

static void DrawAList(ListHandle thelist, Rect* therect, Str255 thetitle)
{
	Rect rview = *therect;
	
	TextFont(0);
	TextSize(0);
	
	FrameRect(&rview);
	InsetRect(&rview, 1, 1);
	EraseRect(&rview);
	LUpdate(gTheWindow->visRgn,thelist);
	
	MoveTo(therect->left, therect->top - 8);
	DrawString(thetitle);
}

static void DrawFocus(short whichitem, Boolean drawMe)
{
	RgnHandle	innerrgn = NewRgn();
	RgnHandle	outerrgn = NewRgn();
	RgnHandle	framergn = NewRgn();
	Rect		temprect;
	
	switch (whichitem)
	{
		case keWHUpdate:	//update button rgn
			temprect = gUpdateBtnRect;
			InsetRect(&temprect, -2, -2);
			OpenRgn ();
			FrameRoundRect(&temprect ,16, 16);
			CloseRgn(innerrgn);
			InsetRect(&temprect, -2, - 2);
			OpenRgn ();
			FrameRoundRect(&temprect ,16, 16);
			CloseRgn(outerrgn);
			break;
		case keWHServices:	//ServiceList rgn
			temprect = gServiceListRect;
			InsetRect(&temprect, -1, -1);
			RectRgn (innerrgn, &temprect);
			InsetRect(&temprect, -2, -2);
			RectRgn (outerrgn, &temprect);
			break;
		case keWHPersons:	//PersonList rgn
			temprect = gPeopleListRect;
			InsetRect(&temprect, -1, -1);
			RectRgn (innerrgn, &temprect);
			InsetRect(&temprect, -2, -2);
			RectRgn (outerrgn, &temprect);
			break;
		case keWHURL:	//URL button rgn
			temprect = gURLBtnRect;
			InsetRect(&temprect, -2, -2);
			OpenRgn ();
			FrameRoundRect(&temprect ,16, 16);
			CloseRgn(innerrgn);
			InsetRect(&temprect, -2, -2);
			OpenRgn ();
			FrameRoundRect(&temprect ,16, 16);
			CloseRgn(outerrgn);
			break;
	}
	DiffRgn (outerrgn, innerrgn, framergn);
	if (drawMe)
	{
		PaintRgn(framergn);
	}
	else
	{
		EraseRgn(framergn);
	}
	DisposeRgn (innerrgn);
	DisposeRgn (outerrgn);
	DisposeRgn (framergn);
}

static void DrawBrowserWindow(void)
{

	if (gTheWindow)
	{
		SetPort(gTheWindow);
		EraseRect(&gPortRect);
		DrawControls (gTheWindow);
		
		DrawPopUpMenuStuff();

		DrawURLStuff();
		
		DrawAList(gServiceList, &gServiceListRect, "\pServices");
		DrawAList(gPersonList, &gPeopleListRect, "\pPeople on record");
		
		DrawFocus(gHighlightedItem, true);
	}
}

static void SetFocus(WhichHilightEnum which)
{
	if (which>keWHURL) which = keWHUpdate;	//Check to make sure it's in bounds
	
	DrawFocus(gHighlightedItem, false);
	gHighlightedItem = which;
	DrawFocus(gHighlightedItem, true);
}


static void ClearURL(void)
{
	HiliteControl (gURLButton, 255);
	SetPort(gTheWindow);
	gURL[0] = 0; DrawURLStuff(); //clear the URL
}

static void UpdateBrowserWindow(void)
{
	if (gTheWindow)
	{
		BeginUpdate(gTheWindow);
		DrawBrowserWindow();
		EndUpdate(gTheWindow);
	}
}

static void UpdateServices( void )
{
	//OK, immediately do a lookup
	LDelRow(0, 0, gServiceList);	//clear the services list
	LDelRow(0, 0, gPersonList);	//clear the user list
	gServiceToLookup = 0;
	gNameToLookup[0] = 0;
	ClearURL(); //clear the URL
	
	PLstrcpy( gIPAddress, gServerEntries[gServerToShow].ServerIPAddress);	//get the most recent configed address & password
	PLstrcpy( gIPPassword, gServerEntries[gServerToShow].ServerPassword);
		
	FillServices( gIPAddress, gServiceList);// Fill the services in the list
	SetFocus(keWHServices);	//set the highlighted area to be the services list
	InitCursor();
}

static void GetServiceFromList( void )
{
	Cell	theCell;
	short	dataLen;
	
	theCell.h = 0;
	theCell.v = 0;
	if ( LGetSelect(true, &theCell, gServiceList))
	{
		dataLen = 4;
		LGetCell (&gServiceToLookup, &dataLen, theCell, gServiceList);
	}
	else gServiceToLookup = 0;
	ClearURL(); //clear the URL
	gNameToLookup[0] = 0; LDelRow(0, 0, gPersonList);	//clear the user list
}

static void GetNameFromList( void )
{
	Cell	theCell;
	short	dataLen;
	
	theCell.h = 0;
	theCell.v = 0;
	if ( LGetSelect(true, &theCell, gPersonList))
	{
		dataLen = 255;
		LGetCell (&gNameToLookup[1], &dataLen, theCell, gPersonList);
		gNameToLookup[0] = dataLen;
	}
	else gNameToLookup[0] = 0;
	ClearURL(); //clear the URL
}

static void HandleServerPopupMenu(void)
{
	short	index;
	MenuHandle	servermenu;
	Point	mypoint;
	Rect	rview;
	
	SetPort(gTheWindow);
	rview = gSLMenuRect;
	servermenu = NewMenu(1, "\pServers");
	InsertMenu(servermenu, -1);
	for (index=0; index<8; index++)
	{
		if (gServerEntries[index].ServerName[0])
		{
			AppendMenu(servermenu, gServerEntries[index].ServerName);
		}
	}
		
	EraseRect(&rview);
	mypoint.h = rview.left; mypoint.v = rview.top;
	LocalToGlobal(&mypoint);
	index = LoWord(PopUpMenuSelect(servermenu, mypoint.v, mypoint.h,
		 gServerToShow+1));
	if (index)
	{
		gServerToShow = index - 1;
		PLstrcpy( gIPName, gServerEntries[gServerToShow].ServerName);
		PLstrcpy( gIPAddress, gServerEntries[gServerToShow].ServerIPAddress);
		PLstrcpy( gIPPassword, gServerEntries[gServerToShow].ServerPassword);
		DrawPopUpMenuStuff();
		UpdateServices();
	}
	DeleteMenu (1);
	DisposeMenu (servermenu);
	DrawPopUpMenuStuff();
}

static void HandleServiceListClick(Point thepoint)
{
	Boolean DidDoubleClick;
	
	SetFocus(keWHServices);	//set the focus on us
	
	DidDoubleClick = LClick(thepoint,0,gServiceList);
	
	GetServiceFromList();
	
	if (gServiceToLookup)
	{
		LDelRow(0, 0, gPersonList);	//clear the user list
		ClearURL(); //clear the URL
		
		// Fill the user names in the list.
		PLstrcpy( gIPAddress, gServerEntries[gServerToShow].ServerIPAddress);	//get the most recent configed address & password
		PLstrcpy( gIPPassword, gServerEntries[gServerToShow].ServerPassword);
		
		FillNames(gIPAddress, gServiceToLookup, gIPPassword, gPersonList, "\p");
	}
	InitCursor();
}

static void HandlePersonListClick(Point thepoint)
{
	Boolean DidDoubleClick;
	
	SetFocus(keWHPersons);	//set the focus on us
	
	DidDoubleClick = LClick(thepoint,0,gPersonList);
				
	GetNameFromList();
	
	if (gNameToLookup[0])
	{
		// look up the URL
		PLstrcpy( gIPAddress, gServerEntries[gServerToShow].ServerIPAddress);	//get the most recent configed address & password
		PLstrcpy( gIPPassword, gServerEntries[gServerToShow].ServerPassword);
		
		RetrieveURL(gIPAddress, gServiceToLookup, gIPPassword, gNameToLookup, gURL);
		DrawURLStuff();	//Draw it
		if (gURL[0])	//enable the URL button if we've got one
		{
			HiliteControl (gURLButton, 0);
		}
		else
		{
			HiliteControl (gURLButton, 255);
		}
		
		if (DidDoubleClick)	//go ahead and launch the URL
		{
			if (gURL[0]>0)
				LaunchURL(gURL);
		}
	}
	InitCursor();
}

static Boolean HandleListKey(char key, ListHandle thelist)
{
	Cell	thecell;
	switch (key)
	{
		case 31:		//down arrow.  
			if ((*thelist)->dataBounds.bottom==0)
			{
				return false;
			}
			thecell.h = 0;
			thecell.v = 0;
			if (LGetSelect(true,&thecell,thelist))
			{
				LSetSelect(false, thecell, thelist);
				thecell.v ++;
			}
			if (thecell.v>=(*thelist)->dataBounds.bottom)
			{
				thecell.v = 0;
			}
			LSetSelect(true, thecell, thelist);
			if ((thecell.v<(*thelist)->visible.top)
				|| (thecell.v>=(*thelist)->visible.bottom))
			{
				LAutoScroll(thelist);
			}
			if (thelist==gServiceList)
				GetServiceFromList();
				else GetNameFromList();
			return true;
			break;
		case 30:		//up arrow
			if ((*thelist)->dataBounds.bottom==0)
			{
				return false;
			}
			thecell.h = 0;
			thecell.v = 0;
			if (LGetSelect(true,&thecell,thelist))
			{
				LSetSelect(false, thecell, thelist);
			}
			else
			{
				thecell.v = (*thelist)->dataBounds.bottom;
			}
			thecell.v --;
			if (thecell.v<0)
			{
				thecell.v = (*thelist)->dataBounds.bottom-1;
			}
			LSetSelect(true, thecell, thelist);
			if ((thecell.v<(*thelist)->visible.top)
				|| (thecell.v>=(*thelist)->visible.bottom))
			{
				LAutoScroll(thelist);
			}
			if (thelist==gServiceList)
				{
					GetServiceFromList();
				}
				else 
				{
					GetNameFromList();
				}
			return true;
			break;
		}

}

static void BlinkControl(ControlHandle thecontrol)
{
	long				ignoreLong;
	
	HiliteControl(thecontrol, true);
	Delay(7, &ignoreLong);
	HiliteControl(thecontrol, false);
}


static Boolean HandleKeystroke(EventRecord* event)
{
	char key;
	
	key = event->message & charCodeMask;
	switch (key)
	{
		case 9:	//tab
			SetFocus( (WhichHilightEnum) ( (short)gHighlightedItem + 1));	//there's gotta be an easier way
			return true;
		case 3:	//enter
		case 13: //return		Either select from the list, or click on the highlighted button
			switch (gHighlightedItem)
			{
				case keWHUpdate:
					BlinkControl(gUpdateButton);
					UpdateServices();
					return true;
				case keWHServices:			//get list of people for the selected service
					GetServiceFromList();
					
					if (gServiceToLookup)
					{
						LDelRow(0, 0, gPersonList);	//clear the user list
						ClearURL(); //clear the URL
						// Fill the user names in the list
						PLstrcpy( gIPAddress, gServerEntries[gServerToShow].ServerIPAddress);	//get the most recent configed address & password
						PLstrcpy( gIPPassword, gServerEntries[gServerToShow].ServerPassword);
						
						FillNames(gIPAddress, gServiceToLookup, gIPPassword, gPersonList, "\p");
						
						SetFocus(keWHPersons);	//highlight the user list
						return true;
					}
					break;
				case keWHPersons:
					GetNameFromList();
					
					if (gNameToLookup[0])
					{
						// look up the URL
						PLstrcpy( gIPAddress, gServerEntries[gServerToShow].ServerIPAddress);	//get the most recent configed address & password
						PLstrcpy( gIPPassword, gServerEntries[gServerToShow].ServerPassword);
						
						RetrieveURL(gIPAddress, gServiceToLookup, gIPPassword, gNameToLookup, gURL);
						InitCursor();
						DrawURLStuff();	//Draw it
						if (gURL[0])	//enable the URL button if we've got one
						{
							HiliteControl (gURLButton, 0);
						}
						else
						{
							HiliteControl (gURLButton, 255);
						}
						SetFocus(keWHURL);	//highlight the URL button
						return true;
					}
					break;
				
				case keWHURL:
					if (gURL[0]>0)
					{
						BlinkControl(gURLButton);
						LaunchURL(gURL);
						return true;
					}
					break;
			}
			break;
		case 31:	//up and down arrows
		case 30:
			switch (gHighlightedItem)
			{
				case keWHServices:
					HandleListKey(key, gServiceList);
					return true;
				case keWHPersons:
					HandleListKey(key, gPersonList);
					return true;
			}
			break;
	}
}

Boolean IPLSBRWinHandleEvent(EventRecord* macEvent)
{
	WindowPtr	theWindow;
	//Boolean		hit;
	char		key;
	Point		aPoint;
	short		theaction;
	Rect		boundsRect;
	ControlHandle	thecontrol;
	char		thechar;
	

	switch ( macEvent->what ) {
		case mouseDown:
			theaction = FindWindow (macEvent->where, &theWindow);
			switch (theaction)
			{
				case inSysWindow:
					SystemClick(macEvent, theWindow);
					return true;
					break;
				case inDrag:
					SetRect(&boundsRect, -32767, -32767, 32767, 32767);
					DragWindow(theWindow, macEvent->where, &boundsRect);
					return true;
					break;
				case inContent:
					if (theWindow==gTheWindow)
					{
						SetPort(gTheWindow);
						aPoint = macEvent->where; GlobalToLocal(&aPoint);
						
						if  (FindControl(aPoint, gTheWindow, &thecontrol)==inButton)
						{
							if (TrackControl(thecontrol, aPoint, nil)==inButton)
							{
								switch (GetControlReference (thecontrol))
								{
									case keUpdateButton:	//update the list of services
										UpdateServices();
										break;
									case keURLButton:	//launch the URL
										if (gURL[0]>0)
											LaunchURL(gURL);
										break;
								}
							}
						}
						else if (PtInRect(aPoint, &gSLMenuRect))
							HandleServerPopupMenu();
						else if (PtInRect(aPoint, &gServiceListRect))
							HandleServiceListClick(aPoint);
						else if (PtInRect(aPoint, &gPeopleListRect))
							HandlePersonListClick(aPoint);
						return true;
					}
					break;
				case inGoAway:
					if ((theWindow==gTheWindow)&&TrackGoAway(theWindow,macEvent->where))
					{
						gDoneFlag = false;
					}
			}
			break;
		case keyDown:
		case autoKey:
			if (!(macEvent->modifiers & cmdKey ))		//Don't handle command keys
				return HandleKeystroke(macEvent);
			break;
		case updateEvt:
			if ( (WindowPtr)macEvent->message==gTheWindow)
			{
				UpdateBrowserWindow();
				return true;
			}
			break;
	}
	return false;
}

void IPLSBRWinClose(void)
{
	LDispose(gServiceList);
	LDispose(gPersonList);
	CloseWindow (gTheWindow);
}


