/**********************************************************************************
	FILE: HandleIPLSCalls.h
	Description: These routines put an easy wrapper on our communications with
		the servers.

	1997, CE Software, Inc.  All rights reserved.
	P.O. Box 65580
	West Des Moines, Iowa 50265 U.S.A.

***********************************************************************************/
#include "Idler.h"
#include "BeachBall.h"

class IPLSIdler : public Idler
{
	private:
		long			mlWNEDelay;
 	
	protected:
						IPLSIdler		(const IPLSIdler& oRHS);
		IPLSIdler&	operator=		(const IPLSIdler& oRHS);
		virtual void	YieldAction				(void);

	public:
						IPLSIdler		(void);
		virtual			~IPLSIdler	(void)	{	}
};

// structure used for registration
struct RegisterEntry {
	Str63	myIPAddress;	// IP address (xxx.xxx.xxx.xxx:xxx)
	OSType	myType;			// four character identifier of register, http for web page
	OSType	mySignature;	//
};
typedef struct RegisterEntry RegisterEntry;

extern BeachBall gTheBall;
extern IPLSIdler gTheIdler;

void FillServices(Str255 theIPAddress, ListHandle thelist);
void FillNames(Str255 theIPAddress, OSType typetofind, Str255 thePassword, ListHandle thelist, Str31 MyName);
void RetrieveURL(Str255 theIPAddress, OSType typetofind, Str255 thePassword,  Str255 thename, Str255 theURL);
void LaunchURL(Str255 theURL);

OSErr DoRegister(Boolean DoAdd, Str31 theName, Str255 theIPAddress, Str255 thePassword,
	RegisterEntry* thelist, short sizeoflist);

OSErr DoQTLKRegister(Boolean DoAdd, Str31 theName, Str255 theIPAddress, unsigned short theport, Str255 thePassword, OSType thetype);
