#ifndef IPLSBROTEndPoint_HPP
#define IPLSBROTEndPoint_HPP

//+++Header
/**********************************************************************************
	FILE: IPLSBROTEndPoint_HPP
	Description:  Implementation of class IPLSBROTEndPoint

	1997, CE Software, Inc.  All rights reserved.
	P.O. Box 65580
	West Des Moines, Iowa 50265 U.S.A.

***********************************************************************************/

//+++Inc - Includes for files not directly related to this project
#include <OpenTransport.h>
#include <OpenTptInternet.h>
#include <Types.h>

#include "OTEndPoint.h"

//+++Inc - Includes for files directly related to this project

//+++ForwardDcl
class Idler;

#define		kDefaultIPLSPort	1026

//stolen from Connection so we don't have to link it all in
long GetLimit (short iResID, long lDefault);

//+++Class
class IPLSBROTEndPoint:public OTEndPoint
{
	public:
		//+++Enums
		enum	eIPLSError
		{
			keNotOpenErr = 1,
			keInvalidPasswordErr,
			keAborted								// Operation aborted by close request
		};

	private:
		char*	mfInComingData;		//data being received
		short	mfBytesReceived;
		short	mfBufferSize;
	
		
	public:
						IPLSBROTEndPoint		(void);
		virtual			~IPLSBROTEndPoint		(void);
		
		OSErr			ReadAString (Idler& oIdler, Str255 thestr );
		
		OSErr			GetDomainName( char *dest );
};

// Streams

#endif		//IPLSBROTEndPoint_HPP
