#ifndef WindowHandler_H
#define WindowHandler_H

/**********************************************************************************
	FILE: WindowHandler.h
	Description: A window handler.  Sorta kinda like another framework, something
		I'm sure the whole programming world agrees we need
		
		We put the pointer to the class in the window handle of a window, and the only
		windows we have are this.  (I know, dangerous assumption).
		
		It is never called directly, it's called to be derived from

	1997, CE Software, Inc.  All rights reserved.
	P.O. Box 65580
	West Des Moines, Iowa 50265 U.S.A.

***********************************************************************************/

Boolean	IsMagicWindow(WindowPtr thewind);	// Is this a windowhandler window?
Boolean DoHandleEvent(EventRecord* MacEvent, WindowPtr thewind);
Boolean DoHandleMenu(short menuID, short itemID, WindowPtr thewind);
void DoSetupMenus( void );
void IdleWindow(WindowPtr thewind);
Boolean TryClose(WindowPtr thewind);
	// Call our windows.  The above is all our base class needs to know
	
class WindowHandler
{
	
	public:
		//+++Enums

	protected:
		WindowPtr		mfTheWind;

						WindowHandler		(const WindowHandler& oRHS);
		WindowHandler&	operator=		(const WindowHandler& oRHS);
		
		// Specific event handlers
		virtual void		HandleContentClick(EventRecord*	MacEvent);
		virtual Boolean		HandleKeystroke(EventRecord*	MacEvent);
		virtual void		HandleUpdateEvent(void);
		virtual void		HandleDraw(void);
		
	public:
						WindowHandler		(short theResID);
		virtual			~WindowHandler		(void);
		
		virtual Boolean OKToClose(void);
		
		virtual Boolean	HandleEvent(EventRecord*	MacEvent);
		virtual void	SetupMenus( void );
		virtual Boolean	HandleMenu(short menuID, short itemID);
		virtual void	DoIdle(void);
};

#endif
