/**********************************************************************************
	FILE: IPLSRegisterConfig.cp
	Description: Our Preferences structure, and the routines that read/write the
		prefs and allow the user to configure them.
		
		Not an example of good programming.  Uses a string constant for the prefs
		file name, so it would have localization problems.

	1997, CE Software, Inc.  All rights reserved.
	P.O. Box 65580
	West Des Moines, Iowa 50265 U.S.A.

***********************************************************************************/

#include "IPLSRegisterConfig.h"

RegisterPrefs gRegisterPrefs;
FSSpec		gPrefsSpec;	//the file to put our prefs in
Boolean		WeAreRegistered = false;

RegisterPrefs tempPrefs;
RegisterEntry	tempEntry;

static void RegisterMe(Boolean DoAdd)	//call the wrapper routine
{
	if (DoRegister(DoAdd, gRegisterPrefs.rpServerName, gRegisterPrefs.rpServerIPAddress,
		gRegisterPrefs.rpServerPassword, gRegisterPrefs.rpEntry, numEntries)==noErr)
	{
		WeAreRegistered = DoAdd;
	}
	InitCursor();
}


void InitRegisterList(void)
{
	//try to read in prefs
	OSErr	theerr;
	short	vref;
	long	dirID;
	short	refnum;
	long	count;
	short	index;
	
	gRegisterPrefs.rpServerName[0] = 0;	//no user name
	gRegisterPrefs.rpServerIPAddress[0]=0; //no server
	gRegisterPrefs.rpServerPassword[0] = 0; //no password
	for (index = 0; index<numEntries; index++)
	{
		gRegisterPrefs.rpEntry[index].myIPAddress[0] = 0;	//clear the IP address
		gRegisterPrefs.rpEntry[index].myType = 0;	//clear the IPLS type
		gRegisterPrefs.rpEntry[index].mySignature = 0;	//clear the signature
	}
	
	
	theerr = FindFolder(kOnSystemDisk, kPreferencesFolderType, false, &vref, &dirID);
	theerr = FSMakeFSSpec(vref, dirID, "\pIPLS Registration List", &gPrefsSpec);
	theerr = FSpOpenDF(&gPrefsSpec, 0, &refnum);
	if (theerr==noErr)
	{
		count = sizeof(gRegisterPrefs);
		theerr = FSRead(refnum, &count, &gRegisterPrefs);
		theerr = FSClose(refnum);
		RegisterMe(true);
	}
	else
	{
		if (!ConfigRegisterList(true))	//Initial configuration
			ExitToShell();
	}
}

static void OSTypeToStr(OSType thetype, Str255 thestr)
{
	if (!thetype)
	{
		thestr[0]=0;
	}
	else
	{
		thestr[0] = 4;
		BlockMove(&thetype, &thestr[1], 4);
	}
}

static OSType StrToOSType( Str255 thestr)
{
	OSType	tempOS='____';	//make sure any extra characters are underscores
	
	if (!thestr[0])
	{
		return 0;
	}
	else
	{
		if (thestr[0]>4) thestr[0] = 4;
		BlockMove(&thestr[1], &tempOS, thestr[0]);
		
		return tempOS;
	}
}

static void BlinkButton(DialogPtr theDialog,
				short btnNumber)
{
	Handle				itemHandle;
	short				itemType;
	Rect				itemRect;
	long				ignoreLong;
	
	GetDItem(theDialog, btnNumber, &itemType, &itemHandle, &itemRect);
	HiliteControl((ControlHandle)itemHandle, true);
	Delay(7, &ignoreLong);
	HiliteControl((ControlHandle)itemHandle, false);
}

static void SetTheClick(DialogPtr d, short whichitem, Boolean theval)
{
	short	dtype;
	Handle	ditem;
	Rect	rview;

	GetDialogItem(d,whichitem,&dtype,&ditem,&rview);
	if (theval)
	{
		SetControlValue((ControlHandle)ditem, 1);
	}
	else
	{
		SetControlValue((ControlHandle)ditem, 0);
	}
}

static pascal GetFullServiceName(OSType thetype, Str255 thename)
{
	OSTypeToStr(thetype, thename);
	switch(thetype)
	{
		case 0:
			PLstrcpy(thename, "\pNone");
			break;
		case 'http':
			PLstrcat(thename,"\p Web pages");
			break;
		case 'ftp_':
			PLstrcat(thename,"\p FTP File Upload/download");
			break;
		case 'fing':
			PLstrcat(thename,"\p Finger (Personal information)");
			break;
		case 'goph':
			PLstrcat(thename,"\p Gopher (Searchable information)");
			break;
		default:
			PLstrcat(thename,"\p Unknown ");
			break;
	}

}

static pascal void RegisterDialogItem(DialogPtr thedialog, short itemnum)
{
	short	dtype;
	Handle	ditem;
	Rect	rview;
	short	whichserver = itemnum - 6;
	Str255	tempstr;

	GetDialogItem(thedialog,itemnum,&dtype,&ditem,&rview);
	EraseRect(&rview);
	rview.right -= 1; rview.bottom -= 1;
	FrameRect(&rview);
	MoveTo(rview.left+1, rview.bottom);
		LineTo(rview.right, rview.bottom);
		LineTo(rview.right, rview.top+1);
	
	if (tempPrefs.rpEntry[whichserver].myType)
	{
		MoveTo(rview.left+4, rview.bottom-6);
		TextFont(applFont); TextSize(9);
		
		GetFullServiceName(tempPrefs.rpEntry[whichserver].myType, tempstr);
		DrawString(tempstr);
		
		DrawString("\p @ ");
		
		if (tempPrefs.rpEntry[whichserver].myIPAddress[0]==0)
		{
			DrawString("\pthis computer");
		}
		else
		{
			DrawString(tempPrefs.rpEntry[whichserver].myIPAddress);
		}
		
		if (tempPrefs.rpEntry[whichserver].mySignature)
		{
			OSTypeToStr(tempPrefs.rpEntry[whichserver].mySignature, tempstr);
			DrawString("\p when "); DrawString(tempstr); DrawString("\p is running");
		}
		
		TextFont(0); TextSize(0);
	}
}
	
static pascal void EntryDialogItem(DialogPtr thedialog, short itemnum)
{
	short	dtype;
	Handle	ditem;
	Rect	rview;
	short	whichserver = itemnum - 6;
	Str255	tempstr;
	
	RgnHandle	temprgn;
	

	GetDialogItem(thedialog,itemnum,&dtype,&ditem,&rview);
	EraseRect(&rview);
	switch(itemnum)
	{
		case 4:
			EraseRect(&rview);
			GetFullServiceName(tempEntry.myType, tempstr);
			rview.right-=2;
			rview.bottom -=2;
			PenSize(2,2);
			MoveTo(rview.left+2, rview.bottom);
			LineTo(rview.right,rview.bottom);
			LineTo(rview.right, rview.top+2);
			PenSize(1,1);
			FrameRect(&rview);
			InsetRect(&rview, 1, 1);
			temprgn = NewRgn();
			OpenRgn();
			MoveTo(rview.right-2, rview.top+4);
			Line(-5, 5);
			Line(-5, -5);
			Line(10,0);
			CloseRgn(temprgn);
			PaintRgn(temprgn);
			DisposeRgn(temprgn);
			
			rview.right -= 12;
			TETextBox(&tempstr[1], tempstr[0], &rview, 0);

			TextFont(0);
			TextSize(0);
			break;

	}
}
	
static pascal void OutlineDialogItem(DialogPtr thedialog, short itemnum)
{
	short	dtype;
	Handle	ditem;
	Rect	rview;

	GetDialogItem(thedialog,itemnum,&dtype,&ditem,&rview);
	PenSize(2,2);
	FrameRoundRect(&rview, 16, 16);
	PenSize(1,1);
}

static pascal Boolean ConfigDialogEventFilter(DialogPtr pDialog,
									EventRecord *macEvent,
									short *itemHit)
	{
	#define kDelay			7
	
	short	itemType;
	ControlHandle	itemHandle;
	Rect	itemRect;
	Cell	thecell;

	switch (macEvent->what)
		{
		case keyDown:
		case autoKey:
			switch (macEvent->message & charCodeMask)
				{
				case 0x03:		// enter key
				case 0x0D:		// return key
					GetDItem(pDialog, 1, &itemType, &((Handle)itemHandle), &itemRect);
					if ((*itemHandle)->contrlHilite)
					{
						macEvent->what = 0;
						return	false;
					}
					else
					{
						BlinkButton(pDialog, 1);
						*itemHit = 1;
						return true;
					}
				case 0x1B:		// escape key
					BlinkButton(pDialog, 2);
					*itemHit = 2;
					return true;
				case '.':		//command-period
					if (macEvent->modifiers & cmdKey)
					{
						BlinkButton(pDialog, 2);
						*itemHit = 2;
						return true;
					}
				default:
					return false;
				}
			break; //of keydown
		default:
			return false;
		}
	}

static Boolean EnterType(OSType* thetype)
{
	DialogPtr mydialog;
	short	dtype;
	Handle	ditem;
	Rect	rview;
	short	itemhit;
	
	Str255	tempstr;

	ModalFilterUPP	OurFilterUPP;
	UserItemUPP	OurItemUPP;
	
	mydialog=GetNewDialog(134,nil,(WindowPtr)-1);
	
	OurItemUPP = NewUserItemProc(OutlineDialogItem);	//outline the OK button
	GetDialogItem(mydialog,5,&dtype,&ditem,&rview);
	SetDialogItem(mydialog,5,dtype,(Handle)OurItemUPP,&rview);
	
	// stuff the type
	GetDialogItem(mydialog,3,&dtype,&ditem,&rview);
	OSTypeToStr(*thetype, tempstr);
	SetDialogItemText (ditem, tempstr);
	SelectDialogItemText (mydialog, 3, 0, 32767);
	
	// Just call ModalDialog with a simple filter for escape, command period, etc.
	OurFilterUPP = NewModalFilterProc(ConfigDialogEventFilter);
	InitCursor();
	do
	{
		ModalDialog(OurFilterUPP, &itemhit);
	}
	while (itemhit>2);
	DisposeRoutineDescriptor(OurFilterUPP);
	
	if (itemhit==ok)
	{
		GetDialogItem(mydialog,7,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, tempstr);
		*thetype = StrToOSType(tempstr);
	}
	
	DisposeRoutineDescriptor(OurItemUPP);
	DisposeDialog(mydialog);
	
	return (itemhit==ok);

}

static Boolean EditAnEntry(short whichserver)
{
	DialogPtr mydialog;
	short	dtype;
	Handle	ditem;
	Rect	rview;
	short	itemhit;
	
	Str255	tempstr;
	long	templong;

	OSErr	theerr;
	short	refnum;
	long	count;
	
	short	i;
	short	whichitem;
	Point	mypoint;
	
	Boolean	DoCalcURL;
	MenuHandle	typemenu;
	
	ModalFilterUPP	OurFilterUPP;
	UserItemUPP	OurItemUPP;
	UserItemUPP OurEntryUPP;
	
	mydialog=GetNewDialog(133,nil,(WindowPtr)-1);
	HideDialogItem (mydialog, 8);	//hide the application stuff we don't do yet
	HideDialogItem (mydialog, 9);
	HideDialogItem (mydialog,10);
	HideDialogItem (mydialog,13);
	
	OurItemUPP = NewUserItemProc(OutlineDialogItem);	//outline the OK button
	GetDialogItem(mydialog,14,&dtype,&ditem,&rview);
	SetDialogItem(mydialog,14,dtype,(Handle)OurItemUPP,&rview);
	
	OurEntryUPP = NewUserItemProc(EntryDialogItem);	//draw our items
	GetDialogItem(mydialog,4, &dtype, &ditem, &rview);
	SetDialogItem(mydialog, 4, dtype, (Handle)OurEntryUPP, &rview);
	GetDialogItem(mydialog,	8, &dtype, &ditem, &rview);
	SetDialogItem(mydialog, 8, dtype, (Handle)OurEntryUPP, &rview);
	
	typemenu = GetMenu(1);
	InsertMenu(typemenu, -1);

	tempEntry = tempPrefs.rpEntry[whichserver];
	
	// stuff the entries
	GetDialogItem(mydialog,7,&dtype,&ditem,&rview);
	SetDialogItemText (ditem, tempEntry.myIPAddress);
	
	DoCalcURL = (tempEntry.myIPAddress[0]==0);
	SetTheClick(mydialog, 5, DoCalcURL);
	SetTheClick(mydialog, 6, !DoCalcURL);
	
	// Just call ModalDialog with a simple filter for escape, command period, etc.
	OurFilterUPP = NewModalFilterProc(ConfigDialogEventFilter);
	InitCursor();
	do
	{
		ModalDialog(OurFilterUPP, &itemhit);
		switch (itemhit)
		{
			case 4:	//Popup Menu
				SetPort(mydialog);
				GetDialogItem(mydialog,4,&dtype,&ditem,&rview);
				mypoint.h = rview.left; mypoint.v = rview.top;
				LocalToGlobal(&mypoint);
				switch(tempEntry.myType)
				{
					case 0:
						whichitem = 0;
						break;
					case 'http':
						whichitem = 1;
						break;
					case 'ftp_':
						whichitem = 2;
						break;
					case 'fing':
						whichitem = 3;
						break;
					case 'goph':
						whichitem = 4;
						break;
					default:
						whichitem = 5;
						break;
				}
				i = LoWord(PopUpMenuSelect(typemenu, mypoint.v, mypoint.h,
					 whichitem));
				if (i)
				{
					if (i==5)
					{
						EnterType(&tempEntry.myType);
					}
					else
					{
						GetMenuItemText(typemenu, i, tempstr);
						BlockMove(&tempstr[1], &tempEntry.myType, 4);
					}
					EntryDialogItem(mydialog,4);
				}
				break;
			case 5:
			case 6:
			case 7:
				DoCalcURL = (itemhit==5);
				SetTheClick(mydialog, 5, DoCalcURL);
				SetTheClick(mydialog, 6, !DoCalcURL);
				break;
		}
	}
	while (itemhit>3);
	DisposeRoutineDescriptor(OurFilterUPP);
	
	if (itemhit==ok)
	{
		if (DoCalcURL)
		{
			tempEntry.myIPAddress[0] = 0;
		}
		else
		{
			GetDialogItem(mydialog,7,&dtype,&ditem,&rview);
			GetDialogItemText (ditem, tempEntry.myIPAddress);
		}
		tempPrefs.rpEntry[whichserver] = tempEntry;
	}
	if (itemhit == 3)	//clear the item out
	{
		tempPrefs.rpEntry[whichserver].myType = 0;
		tempPrefs.rpEntry[whichserver].myIPAddress[0] = 0;
		tempPrefs.rpEntry[whichserver].mySignature = 0;
	}
	
	DeleteMenu(1);
	
	DisposeRoutineDescriptor(OurItemUPP);
	DisposeRoutineDescriptor(OurEntryUPP);
	DisposeDialog(mydialog);
	
	return ((itemhit==ok)||(itemhit==3));

}

Boolean ConfigRegisterList(Boolean firstTime)	//Let the user config the list of entries
{
	DialogPtr mydialog;
	short	dtype;
	Handle	ditem;
	Rect	rview;
	short	itemhit;
	
	Str255	tempstr;
	long	templong;

	OSErr	theerr;
	short	refnum;
	long	count;
	
	short	index;
	
	ModalFilterUPP	OurFilterUPP;
	UserItemUPP	OurItemUPP;
	UserItemUPP OurRegisterUPP;
	
	mydialog=GetNewDialog(132,nil,(WindowPtr)-1);
	
	OurItemUPP = NewUserItemProc(OutlineDialogItem);	//outline the OK button
	GetDialogItem(mydialog,23,&dtype,&ditem,&rview);
	SetDialogItem(mydialog,23,dtype,(Handle)OurItemUPP,&rview);
	
	OurRegisterUPP = NewUserItemProc(RegisterDialogItem);	//draw our items
	for (index = 0; index<numEntries; index++)
	{
		GetDialogItem(mydialog,6+index, &dtype, &ditem, &rview);
		SetDialogItem(mydialog, 6+index, dtype, (Handle)OurRegisterUPP, &rview);
	}
	
	tempPrefs = gRegisterPrefs;
	
	// stuff the entries
	GetDialogItem(mydialog,3,&dtype,&ditem,&rview);
	SetDialogItemText (ditem, tempPrefs.rpServerName);
	SelectDialogItemText (mydialog, 3, 0, 32767);

	GetDialogItem(mydialog,4,&dtype,&ditem,&rview);
	SetDialogItemText (ditem, tempPrefs.rpServerIPAddress);
	
	GetDialogItem(mydialog,5,&dtype,&ditem,&rview);
	SetDialogItemText (ditem, tempPrefs.rpServerPassword);
	
	// Just call ModalDialog with a simple filter for escape, command period, etc.
	OurFilterUPP = NewModalFilterProc(ConfigDialogEventFilter);
	InitCursor();
	do
	{
		ModalDialog(OurFilterUPP, &itemhit);
		if ((itemhit>11)&&(itemhit<18))
		{
			if (EditAnEntry(itemhit - 12))
			{
				SetPort(mydialog);
				RegisterDialogItem(mydialog, itemhit - 6);
			}
		}
		if ((itemhit>5)&&(itemhit<12))
		{
			if (EditAnEntry(itemhit - 6))
			{
				SetPort(mydialog);
				RegisterDialogItem(mydialog, itemhit);
			}
		}
	}
	while (itemhit>2);
	DisposeRoutineDescriptor(OurFilterUPP);
	
	if (itemhit==ok)
	{
		if (WeAreRegistered) RegisterMe(false);
		GetDialogItem(mydialog,3,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, tempPrefs.rpServerName);

		GetDialogItem(mydialog,4,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, tempPrefs.rpServerIPAddress);
		
		GetDialogItem(mydialog,5,&dtype,&ditem,&rview);
		GetDialogItemText (ditem, tempPrefs.rpServerPassword);
		
		gRegisterPrefs = tempPrefs;
		
		theerr = FSpCreate(&gPrefsSpec, 'IPLS', 'DATA', smSystemScript);
		theerr = FSpOpenDF(&gPrefsSpec, 0, &refnum);
		if (theerr==noErr)
		{
			count = sizeof(gRegisterPrefs);
			theerr = FSWrite(refnum, &count, &gRegisterPrefs);
			theerr = FSClose(refnum);
		}
		RegisterMe(true);
	}
	
	DisposeRoutineDescriptor(OurItemUPP);
	DisposeRoutineDescriptor(OurRegisterUPP);
	DisposeDialog(mydialog);
	
	return (itemhit==ok);

}

void CloseRegisterList(void)
{
	if (WeAreRegistered)
		RegisterMe(false);
}