/**********************************************************************************
	FILE: IPLSServer.h
	Description: This defines our various data structures, and has the code to run
		things

	1997, CE Software, Inc.  All rights reserved.
	P.O. Box 65580
	West Des Moines, Iowa 50265 U.S.A.

***********************************************************************************/

struct IPLSEntry {
	Str31	iplsUserName;	//User name in bar format (Brown|Donald)
	OSType	iplsRegisterType;	// type of registration, http for web pages
	Str63	iplsURL;			// URL of registration
	Str15	iplsPersonalPassword;	//Password for individual
	unsigned long	iplsLastEntered;	//date/time this entry last received
};
typedef struct IPLSEntry IPLSEntry;

struct IPLSPrefs {
	
	unsigned short	ipspLookupPort;		//port used for receiving Lookup TCP/IP connections
	Str15			ipspRegisterPassword;	//password, if any, to register
	Str15			ipspLookupPassword;		//password, if any, to look up
	short			ipspNumEntries;			//size of our array of entries
};
typedef struct IPLSPrefs IPLSPrefs;

extern	IPLSPrefs	gServerPrefs;	//the prefs used by the system
extern	IPLSEntry*	gServerData;	//the array of entries
extern	long	recordsInUse;
extern	unsigned long gStartupDate;	//the time we last started

void ServerInit(void);	//read in the prefs (configure if necessary), open the endpoints, etc.
Boolean ServerConfigure(void);	//Have user enter our complex configurations
void ServerIdle(void);	//this is called to check on the packets, handle connections, etc.
void ServerShutdown(void);	//close the endpoints, etc.

Boolean	AddRecord(IPLSEntry* therecord);	//update the record in the array
