#include <iostream>
#include <set>

void main(void)
{
	typedef	set<char, less<char>, allocator<char> > MySet;
	typedef	multiset<char, less<char>, allocator<char> > MyMultiSet;
	ostream_iterator<char, char, char_traits<char> >	out(cout);
	char	start[] = "sleep is a poor substitute for caffeine";
	MySet	s(start, start + strlen(start));
	MyMultiSet	ms;
	ms.insert(start, start + strlen(start));

	cout << "      start: ";
	copy(s.begin(), s.end(), out);
	cout << "\n      start: ";
	copy(ms.begin(), ms.end(), out);

	MySet::iterator	si1, si2;
	MyMultiSet::iterator	msi1, msi2;
	si1 = s.lower_bound('b');
	si2 = s.upper_bound('s');
	s.erase(' ');
	s.erase(si1, si2);
	msi1 = ms.lower_bound('b');
	msi2 = ms.upper_bound('s');
	ms.erase(' ');
	ms.erase(msi1, msi2);

	cout << "\nremoved b-s: ";
	copy(s.begin(), s.end(), out);
	cout << "\nremoved b-s: ";
	copy(ms.begin(), ms.end(), out);
	cout << "\n";
}
//       start:  abcefilnoprstu
//       start:       aabceeeeefffiiilnooopprrsssstttuu
// removed b-s: atu
// removed b-s: aatttuu
