/*
	Edit(JDK).r

	Really simple Java text editor.

	 1997 by Michael J. Webb (mjw@codewell.com)

*/

#include "Types.r"

/*#include "RunnerTypes.r" */			// mjw - missing file!!!!!!
#include "JavaTypes.r"

// note that the "./lib/" gets expanded in the 'LIBM' resource
// mjw - Change this for your app's ZIP file.
resource 'STR '(1, "Standalone App Class Path") {
	"./lib/Edit.zip:/$INSTALLATION_CLAS/JDK-1.0.2"
};

// Package of main app class.
// mjw - Change this for your app.
resource 'STR '(2, "Main App Class - Run This!") {
	"Edit"
};

/* Junk from sample
resource 'STR#'(1, "Parameters for main(String args[])") {
	{
		"Space is Big",
		"Space is Dark",
		"Its hard to find",
		"A place to park",
		"",
		"Burma Shave"
	}
};
*/

/* Missing file!
resource 'JRun'(1, "Standalone Startup Resource") {
	dontProtectApplication,						// <not implemented yet>
	noVerbose,									// don't be annoying by default
	noDebug,									// <not implemented yet>
	ascyncGC,									// GC occasionally
	noVerboseGC,								// don't annoy me

	noProfileData,								// <not implemented yet>
	noTraceData,								// <not availiable in optimized version>
	
	default,									// use the default "C" stack size
	default,									// use the default "Java" stack size (growable)
	
	default,									// 4 meg was the default maximum
	default,									// 768k was the default minimum
	
	verifyBCRemote,								// don't be _too_ anal, but watch network classes

	1,											// default 'STR ' for class path

	noStartingProps,							// no starting property values
	2,											// 'STR ' of the default app to run
	noStartingAppAboutItem,						// no app - no about
	1,											// 'STR#' for parameters
	
	stderrRedirectionAlias, { 0, 0, 0, 0 },		// no redirection here
	stdoutRedirectionAlias, { 0, 0, 0, 0 },		// no redirection here
	
	":MacJava Prefs:StandaloneSample Prefs",
};

// maps .lib names to resouces.
/* mjw - Change this for your apps */
resource 'LIBM'(1, "./lib/ folder item mappings") {
	{
		"Edit.zip",							// name to replace
		'ZIP!',									// resource type of the replacement
		kAsNamedResource { "Edit.zip" },		// by name or by ID
	}
};

/* mjw - Change this for your apps */

// this reads the binary file Edit.zip into a resource of the given type and name
read 'ZIP!'(128, "Edit.zip") "Edit.zip";

//------------------------------------------------------------------------------------
// Stuff for a normal app.

#ifndef __TYPES_R__
#include "Types.r"
#endif

#ifndef __SYSTYPES_R__
#include "SysTypes.r"
#endif

#define kSignature			'i3'			// Application signature
#define kFileType			'TEXT'			// Data file type
#define kBinFileType		'BEEP'			// Binary file type

#define kBundleID			128
#define kApplicationID		128
#define kDocumentID			129
#define kBinDocumentID		130

type kSignature as 'STR ';
resource kSignature (0,
"Signature",
	purgeable)
{
	"JDK Edit Application  1997 Michael J. Webb"
};

resource 'FREF' (kApplicationID,
"JDK Edit Application",
	purgeable)
{
	'APPL',
	0,
	""
};

resource 'FREF' (kDocumentID,
"JDK Edit Document",
	purgeable)
{
	kFileType,
	1,
	""
};

resource 'FREF' (kBinDocumentID,
"JDK Edit Binary Document",
	purgeable)
{
	kBinFileType,
	1,
	""
};

resource 'BNDL' (kBundleID,
"JDK Edit Application",
	purgeable)
{
	kSignature,
	0,
	{ /* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{ /* array IDArray: 3 elements */
			0, kApplicationID,
			1, kDocumentID,
			2, kBinDocumentID
		},
		/* [2] */
		'FREF',
		{ /* array IDArray: 3 elements */
			0, kApplicationID,
			1, kDocumentID,
			2, kBinDocumentID
		}
	}
};

// The revision of this particular file

RESOURCE 'vers' (1,
"File Version",
	purgeable)
{
	0x00,
	0x00,
	alpha,
	0x001,
	verUs,
	"0.0a1",
	"JDK Edit Application 1997 Michael J. Webb"
};

include "Edit Common.rsrc";
include "JRUN(JDK).rsrc";
