/*
	Edit(RT).r

	Really simple Java text editor.

	 1997 by Michael J. Webb (mjw@codewell.com)

*/

#ifndef __TYPES_R__
#include "Types.r"
#endif

#ifndef __SYSTYPES_R__
#include "SysTypes.r"
#endif

#define kSignature			'i1'			// Application signature
#define kFileType			'TEXT'			// Data file type
#define kBinFileType		'BEEP'			// Binary file type

#define kBundleID			128
#define kApplicationID		128
#define kDocumentID			129
#define kBinDocumentID		130

type kSignature as 'STR ';
resource kSignature (0,
"Signature",
	purgeable)
{
	"Roaster Edit Application  1997 Michael J. Webb"
};

resource 'FREF' (kApplicationID,
"Roaster Edit Application",
	purgeable)
{
	'APPL',
	0,
	""
};

resource 'FREF' (kDocumentID,
"Roaster Edit Document",
	purgeable)
{
	kFileType,
	1,
	""
};

resource 'FREF' (kBinDocumentID,
"Roaster Edit Binary Document",
	purgeable)
{
	kBinFileType,
	1,
	""
};

resource 'BNDL' (kBundleID,
"Roaster Edit Application",
	purgeable)
{
	kSignature,
	0,
	{ /* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{ /* array IDArray: 3 elements */
			0, kApplicationID,
			1, kDocumentID,
			2, kBinDocumentID
		},
		/* [2] */
		'FREF',
		{ /* array IDArray: 3 elements */
			0, kApplicationID,
			1, kDocumentID,
			2, kBinDocumentID
		}
	}
};

// The revision of this particular file

RESOURCE 'vers' (1,
"File Version",
	purgeable)
{
	0x00,
	0x00,
	alpha,
	0x001,
	verUs,
	"0.0a1",
	"Roaster Edit Application 1997 Michael J. Webb"
};

include "Edit Common.rsrc";
