/*
 * JavaTypes.r
 */

#include "JavaResourceTypes.h"

/*
 * A LIBM is looked for as a replacement for things in the lib/ directory.
 * In other words, when sysOpen("lib/javac.properties") gets opened,
 * this table (Get1IndResource is used) is referenced for "javac.properties" and a
 * resource file descriptor is created for it.  Note that it gets opened READ ONLY!
 * Note too that the filename comparison is case sensitive, unlike the macos.
 * You should probably make the target resource purgable, too.
 */

type 'LIBM' {
	integer = $$CountOf(MapArray);
	array MapArray {
		pstring;								// name (javac.properties)
		align word;

		literal longint;						// resource type
		
		switch {
			case kAsNamedResource:
				key integer = kLibEntryName;		// named resource
				pstring;							// resource name
		
			case kAsNumberedResource:
				key integer = kLibEntryNumber;		// spec'd by ID
				integer;							// resource ID
		};
		
		align word;
	};
};