/*
 * Copyright (c) 1996.  Netscape Communications Corporation.  All
 * rights reserved.
 * 
 * Common definitions for ldap example programs.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#if defined( macintosh )
#include <utime.h>
#endif

#include <ldap.h>

/*
 * Host name of LDAP server
 */
#define MY_HOST		"localhost"

/*
 * Port number where LDAP server is running
 */
#define	MY_PORT		LDAP_PORT

/*
 * DN of directory manager entry.  This entry should have write access to
 * the entire directory.
 */
#define MGR_DN		"cn=Directory Manager, o=Ace Industry, c=US"

/*
 * Password for manager DN.
 */
#define MGR_PW		"secret99"

/*
 * Subtree to search
 */
#define	MY_SEARCHBASE	"o=Ace Industry, c=US"

/* 
 * Filter to use when searching.  This one searches for all entries with the
 * surname (last name) of "Jensen".
 */
#define	MY_FILTER	"(sn=Jensen)"

/*
 * Entry to retrieve
 */
#define ENTRYDN "cn=Barbara Jensen, ou=Product Development, o=Ace Industry, c=US"

/*
 * Password for Babs' entry
 */
#define ENTRYPW "hifalutin"

/*
 * Name of file containing filters
 */
#define MY_FILTERFILE   "xmplflt.conf"
 
/*
 * Tag to use when retrieveing filters
 */
#define MY_FILTERTAG    "ldap-example"

