#include "LayoutPane.h"
#include "Appearance.h"
#include "AppearanceHelpers.h"
#include "UDialogUtils.h"

enum
{
	kPrimaryGroup		= 1,
	kUserPane			= 2,
	kSecondaryGroup		= 3,
	kSeparator			= 4,
	kLevel1Radio		= 5,
	kLevel2Radio		= 6,
	kLevel3Radio		= 7,
	kUseMilliCheck		= 8,
	kFullCheck			= 9
};

LayoutPane::LayoutPane( DialogPtr dialog, SInt16 items ) : MegaPane( dialog, items )
{
	ControlHandle		control;
	
	AppendDialogItemList( dialog, 6005, overlayDITL );
	
	UDialogUtils::SetDialogItemValue( dialog, fOrigItems + kPrimaryGroup, 1 );
	UDialogUtils::SetDialogItemValue( dialog, fOrigItems + kLevel3Radio, 1 );
	
	fGroup = new RadioGroup;
	GetDialogItemAsControl( dialog, fOrigItems + kLevel1Radio, &control );
	fGroup->AddControl( control, kLevel1Radio );
	GetDialogItemAsControl( dialog, fOrigItems + kLevel2Radio, &control );
	fGroup->AddControl( control, kLevel2Radio );
	GetDialogItemAsControl( dialog, fOrigItems + kLevel3Radio, &control );
	fGroup->AddControl( control, kLevel3Radio );
}

LayoutPane::~LayoutPane()
{
	ShortenDITL( fDialog, CountDITL( fDialog ) - fOrigItems );
	
	delete fGroup;
}

void
LayoutPane::ItemHit( SInt16 item )
{
	SInt16			localItem;
	ControlHandle	control;
	
	localItem = item - fOrigItems;
	
	switch( localItem )
	{
		case kPrimaryGroup:
			UDialogUtils::ToggleCheckBox( fDialog, item );
			GetDialogItemAsControl( fDialog, fOrigItems + kUserPane, &control );
			if ( UDialogUtils::GetDialogItemValue( fDialog, item ) == 1 )
				ActivateControl( control );
			else
				DeactivateControl( control );
			break;
		
		case kLevel1Radio:
		case kLevel2Radio:
		case kLevel3Radio:
			fGroup->SetValue( localItem );
			break;
		
		case kUseMilliCheck:
		case kFullCheck:
			UDialogUtils::ToggleCheckBox( fDialog, item );
			break;
			
	}
}
