#include "NewButtonPane.h"
#include "Appearance.h"
#include "AppearanceHelpers.h"
#include "UDialogUtils.h"

enum
{
	kBevel1			= 1,
	kToRightBevel	= 2,
	kBelowBevel 	= 3,
	kAboveBevel		= 4,
	kToLeftBevel	= 5,
	kMenuBevel		= 8,
	kMultiMenuBevel	= 9,
	kLeftJustBevel	= 18,
	kCenterJustBevel= 19,
	kRightJustBevel = 20,
	kFullJustBevel	= 21
};

#define MIN( a, b )		( ( (a) < (b) ) ? (a) : (b) )
#define MAX( a, b )		( ( (a) > (b) ) ? (a) : (b) )

NewButtonPane::NewButtonPane( DialogPtr dialog, SInt16 items ) : MegaPane( dialog, items )
{
	ControlHandle		control;
	Boolean				kTrue = true;
	
	AppendDialogItemList( dialog, 6006, overlayDITL );
	
	GetDialogItemAsControl( dialog, fOrigItems + kToRightBevel, &control );
	SetBevelButtonTextPlacement( control, kControlBevelButtonPlaceToRightOfGraphic );

	GetDialogItemAsControl( dialog, fOrigItems + kBelowBevel, &control );
	SetBevelButtonTextPlacement( control, kControlBevelButtonPlaceBelowGraphic );

	GetDialogItemAsControl( dialog, fOrigItems + kAboveBevel, &control );
	SetBevelButtonTextPlacement( control, kControlBevelButtonPlaceAboveGraphic );

	GetDialogItemAsControl( dialog, fOrigItems + kToLeftBevel, &control );
	SetBevelButtonTextPlacement( control, kControlBevelButtonPlaceToLeftOfGraphic );

	GetDialogItemAsControl( dialog, fOrigItems + kMenuBevel, &control );
	SetBevelButtonTextAlignment( control, kControlBevelButtonAlignTextFlushLeft, 3 );
	SetControlData( control, 0, 'pglc', sizeof( kTrue ), (Ptr)&kTrue );

	GetDialogItemAsControl( dialog, fOrigItems + kMultiMenuBevel, &control );
	SetBevelButtonTextAlignment( control, kControlBevelButtonAlignTextFlushLeft, 3 );
	SetControlData( control, 0, 'pglc', sizeof( kTrue ), (Ptr)&kTrue );
	
	fGroup = new RadioGroup;
	GetDialogItemAsControl( dialog, fOrigItems + kLeftJustBevel, &control );
	fGroup->AddControl( control, kLeftJustBevel );
	GetDialogItemAsControl( dialog, fOrigItems + kCenterJustBevel, &control );
	fGroup->AddControl( control, kCenterJustBevel );
	GetDialogItemAsControl( dialog, fOrigItems + kRightJustBevel, &control );
	fGroup->AddControl( control, kRightJustBevel );
	GetDialogItemAsControl( dialog, fOrigItems + kFullJustBevel, &control );
	fGroup->AddControl( control, kFullJustBevel );
	
	fGroup->SetValue( kLeftJustBevel );
}

NewButtonPane::~NewButtonPane()
{
	ShortenDITL( fDialog, CountDITL( fDialog ) - fOrigItems );

	delete fGroup;
}

void
NewButtonPane::ItemHit( SInt16 item )
{
	SInt16			localItem;
	
	localItem = item - fOrigItems;
	
	switch ( localItem )
	{
		case kLeftJustBevel:
		case kRightJustBevel:
		case kFullJustBevel:
		case kCenterJustBevel:
			fGroup->SetValue( localItem );
			break;
	}
}
