/*
	File:		TrapTools.c

	Contains:	Trap Utilities

	Version:	Appearance 1.0

	Author:		Edward Voas

	Copyright:	 1996-1997 by Apple Computer, Inc., all rights reserved.
*/


//------------------------------------------------------------------------------
//	Includes
//------------------------------------------------------------------------------

#include <Traps.h>
#include "TrapTools.h"

//------------------------------------------------------------------------------
//	Private prototypes
//------------------------------------------------------------------------------

static int NumToolboxTraps();

//------------------------------------------------------------------------------
//	Implementation
//------------------------------------------------------------------------------

int NumToolboxTraps()
{
	if (NGetTrapAddress(_InitGraf,ToolTrap) == NGetTrapAddress(0xAA6E,ToolTrap))
		return(0x200);
	else
		return(0x400);
}


TrapType GetTrapType(short theTrap)
{
	return((theTrap & 0x0800) ? ToolTrap : OSTrap);
}

Boolean TrapAvailable(short theTrap)
{
	TrapType	tType;
	
	tType = GetTrapType(theTrap);
	if (tType == ToolTrap) {
		theTrap = theTrap & 0x07FF;
		if (theTrap >= NumToolboxTraps())
			theTrap = _Unimplemented;
	}
	return(NGetTrapAddress(theTrap,tType) != NGetTrapAddress(_Unimplemented,ToolTrap));
}
