/*
	CDemoWindow.cpp
	
	Demo Window for MacHack 97
	
	Macintosh version -- uses Metrowerks PowerPlant
	
	Al Evans
	
	6/12/97
	
*/

#include "CDemoWindow.h"
#include "CGEView.h"

static const ResIDT demoWINDResID	= 128;

static const UInt32 demoWindAttribs = 
	(windAttr_Regular | windAttr_TitleBar | windAttr_Enabled | windAttr_Targetable);
	
CDemoWindow::CDemoWindow( LCommander *inSuperCommander)
	: LWindow(demoWINDResID, demoWindAttribs, inSuperCommander)
{
	mCurrView = new CGEView(this, 128);

	// Get idle time
	StartRepeating();
}

CDemoWindow::~CDemoWindow()
{
	StopRepeating();
	if (mCurrView)
		delete mCurrView;
}

void CDemoWindow::SpendTime(const EventRecord &inMacEvent)
{
	if (mCurrView)
		mCurrView->Idle();
}

void CDemoWindow::Click(SMouseDownEvent &inMouseDown)
{
	if (mCurrView) {
		mCurrView->HandleMouseDown(inMouseDown.macEvent.where);
	}
	else
		LPane::Click(inMouseDown);
}

Rect CDemoWindow::GetWindRect()
{
	SDimension16 frameSize;
	GetFrameSize(frameSize);
	Rect r = {0, 0, frameSize.height, frameSize.width};
	return r;
}

CTabHandle CDemoWindow::GetPalette()
{
	return nil; // Mac version uses system palette
}

GrafPtr CDemoWindow::GetSystemWindow()
{
	return GetMacPort();
}

void CDemoWindow::ActivateSelf()
{
	if (mCurrView)
		mCurrView->Activate(true);
}

void CDemoWindow::DeactivateSelf()
{
	if (mCurrView)
		mCurrView->Activate(false);
}

void CDemoWindow::DrawSelf()
{
	if (mCurrView)
		mCurrView->Draw();
}
