/*
	DemoConversions.cpp
	
	Application-level format conversions used in MacHack demo
	
	Al Evans
	
	6/13/97
	
*/


#include "byteorder.h"
#include "DemoConversions.h"

Point16::operator const Point () const
{
	Point p;
	p.v = v, p.h = h;
	return p;
}

Point16& Point16::operator = ( const Point& p )
{
	v = p.v, h = p.h;
	return *this;
}

void SwapIfRequired( Point16* p)
{
	SwapIfRequired(&p->v);
	SwapIfRequired(&p->h);
}


Rect16::operator const Rect () const
{
	Rect r;
	r.top = top, r.left = left;
	r.bottom = bottom, r.right = right;
	return r;
}

Rect16& Rect16::operator = ( const Rect& r )
{
	top = r.top, left = r.left;
	bottom = r.bottom, right = r.right;
	return *this;
}

void SwapIfRequired( Rect16* r )
{
	SwapIfRequired( &r->top );
	SwapIfRequired( &r->left );
	SwapIfRequired( &r->bottom );
	SwapIfRequired( &r->right );
}


void SwapIfRequired(ViewLayout* view)
{
	SwapIfRequired( &view->viewSize );
	SwapIfRequired( &view->viewCTabID );
	SwapIfRequired( &view->viewBkgID );
	SwapIfRequired( &view->viewBouncerID );
	SwapIfRequired( &view->viewBtnID );
	
}

void SwapIfRequired(ButtonSpec* button)
{
	SwapIfRequired( &button->btnPicResNum );
	SwapIfRequired( &button->btnURLResNum );
	SwapIfRequired( &button->btnTopLeft );
}
