/*
	WinPalette.cpp

	Windows palette creation utility for MacHack 97 demo

	Al Evans

	6/18/97

*/

#include "reschain.h"
#include "WinPalette.h"

struct MacColorTable
{
	int32	seed;
	uint16	flags;
	int16	sizeMinusOne;
	struct Entry
	{
		int16 value;
		uint16 r, g, b;
	};
	Entry	ctEntries [256];
};

typedef struct MacColorTable MacColorTable;

struct PaletteEntries {
	WORD version;
	WORD nEntries;
	PALETTEENTRY pEntries[256];
};

typedef struct PaletteEntries PaletteEntries;


HPALETTE MakePaletteFromResource(int16 palResID)
{
	MacColorTable *cTable = (MacColorTable *) GetResourcePtr('clut', palResID);
	PaletteEntries palEntries;

	// Bottom 10 and top 10 colors are "Windows required colors"
	for (int count = 10; count < 246; count++) {
		PALETTEENTRY *currEntry = &palEntries.pEntries [count];
		// we don't need to swap - we want hi byte, but it's low byte here
		currEntry->peRed   = cTable->ctEntries [count].r;
		currEntry->peGreen = cTable->ctEntries [count].g;
		currEntry->peBlue  = cTable->ctEntries [count].b;
	}

	ReleaseResourcePtr( cTable );

	// Graphic Elements utility
	return Make256IdentityPalette(palEntries.pEntries);
}

