/*
	File:		InternetAccessProperties.cpp

	Contains:	<contents>

	Written by:	Frederic Artru

		Copyright:	 1997 by Apple Computer, Inc., all rights reserved.

     You may incorporate this sample code into your applications without
    restriction, though the sample code has been provided "AS IS" and the
    responsibility for its operation is 100% yours.  However, what you are
    not permitted to do is to redistribute the source as "DSC Sample Code"
    after having made changes. If you're going to re-distribute the source,
    we require that you make it clear in the source that the code was
    descended from Apple Sample Code, but that you've made changes.

	Change History (most recent first):

        <0+>     2/26/97    FA      first checked in
*/


#ifndef _INTERNETACCESSPROPERTIES_
#define _INTERNETACCESSPROPERTIES_

// universal properties
extern const char* kURLURL							= "URLString";
extern const char* kURLResourceSize					= "URLResourceSize";
extern const char* kURLLastModifiedTime				= "URLLastModifiedTime";
extern const char* kURLMIMEType						= "URLMIMEType";
extern const char* kURLFileType						= "URLFileType";
extern const char* kURLFileCreator					= "URLFileCreator";
extern const char* kURLCharacterSet					= "URLCharacterSet";
extern const char* kURLResourceName					= "URLResourceName";
extern const char* kURLHost							= "URLHost";
extern const char* kURLAuthType						= "URLAuthType";
extern const char* kURLUserName						= "URLuserName";
extern const char* kURLPassword						= "URLPassword";
extern const char* kURLStatusString					= "URLStatusString";
extern const char* kURLIsSecure						= "URLIsSecure";
extern const char* kURLCertificate					= "URLCertificate";

// http and https properties
extern const char* kURLHTTPRequestMethod			= "URLHTTPRequestMethod";
extern const char* kURLHTTPRequestHeader			= "URLHTTPRequestHeader";
extern const char* kURLHTTPRequestBody				= "URLHTTPRequestBody";
extern const char* kURLHTTPRespHeader				= "URLHTTPRespHeader";

#endif /* _INTERNETACCESSPROPERTIES_ */
