/*
	File:		SWUtilities.cpp

	Contains:	<contents>

	Written by:	Frederic Artru

		Copyright:	 1997 by Apple Computer, Inc., all rights reserved.

     You may incorporate this sample code into your applications without
    restriction, though the sample code has been provided "AS IS" and the
    responsibility for its operation is 100% yours.  However, what you are
    not permitted to do is to redistribute the source as "DSC Sample Code"
    after having made changes. If you're going to re-distribute the source,
    we require that you make it clear in the source that the code was
    descended from Apple Sample Code, but that you've made changes.

	Change History (most recent first):

         <8>     3/24/97    FA      HasNewIntervalTime now here
         <7>      3/7/97    FA      adding GetTokenText
         <6>      3/5/97    FA      clean up resource calls
         <5>      3/3/97    FA      changes to error code table
         <4>     2/26/97    FA      adding routines to get error message
         <3>     2/11/97    FA      Acquire and Release ICInstance
         <2>     1/31/97    FA      No more TCP management for FTP
         <1>     1/30/97    FA      first checked in
*/

#include <Resources.h>
#include <Files.h>

#include "SWUtilities.h"

extern UInt16 gOldResFile;
extern UInt16 gRefNum;
extern THz gCurrentZone;

OSErr OpenSubwooferForResource()
{
	OSErr err = noErr;

	gOldResFile = 0;
	gCurrentZone = nil;
	
	// set allocation zone to system
	gCurrentZone = GetZone();
	SetZone(SystemZone());

	gOldResFile = CurResFile();
	UseResFile(gRefNum);
	
	return err;
}

void CloseSubwooferForResource()
{
	if ( gOldResFile )
		UseResFile(gOldResFile);
	gOldResFile = 0;

	// set allocation zone back
	if ( gCurrentZone )
		SetZone(gCurrentZone);
	gCurrentZone = nil;
}
