/*
	File:		SubwooferProgress.h

	Contains:	<contents>

	Written by:	Frederic Artru

		Copyright:	 1997 by Apple Computer, Inc., all rights reserved.

     You may incorporate this sample code into your applications without
    restriction, though the sample code has been provided "AS IS" and the
    responsibility for its operation is 100% yours.  However, what you are
    not permitted to do is to redistribute the source as "DSC Sample Code"
    after having made changes. If you're going to re-distribute the source,
    we require that you make it clear in the source that the code was
    descended from Apple Sample Code, but that you've made changes.

	Change History (most recent first):

         <2>      3/4/97    FA      adding file name field
        <0+>      3/3/97    FA      first checked in
*/


#ifndef _SUBWOOFERPROGRESS_
#define _SUBWOOFERPROGRESS_

#include <Dialogs.h>

enum
{
	kProgressDialogResID = 1000,
	kProgressCancelButtonItem = 1,
	kProgressDownloadingItem = 2,
	kProgressBarItem = 3,
	kProgressFileNameItem = 4,
	
	kMinBarberPolePictID = 1000,
	kMaxBarberPolePictID = 1003
};

// types
typedef struct ProgressDataStruct
{
	DialogPtr 	progressDialog;
	PicHandle	barberPolePict[kMaxBarberPolePictID - kMinBarberPolePictID + 1];
	UInt16		whichPict;
} ProgressDataStruct;

OSErr CreateProgress(ProgressDataStruct* progressData, Boolean displayProgress, StringPtr filename);
Boolean DoProgress(ProgressDataStruct* progressData, UInt32 amountDone, UInt32 amountTotal, StringPtr statusString);
void DisposeProgress(ProgressDataStruct* progressData);

#endif /* _SUBWOOFERPROGRESS_ */
